package com.webonlineapp.hyjavaapexdemo.charts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.webonlineapp.hyjavaapexdemo.examplecharts.BarWithNegativeValues;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicBar;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicBox;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicCandleStick;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicColumn;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicHeatmap;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicLine;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicPolarArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicRadar;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicRadial;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicScatter;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicTimeLine;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BasicTreemap;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BoxPlotScatter;
import com.webonlineapp.hyjavaapexdemo.examplecharts.BrushChart;
import com.webonlineapp.hyjavaapexdemo.examplecharts.CandleStickWithLine;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ColorRangeHeatmap;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ColorScaleTreemap;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ColumnWithDataLabels;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ColumnWithNegativeValues;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ColumnWithRotatedLabels;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ComboCandlestick;
import com.webonlineapp.hyjavaapexdemo.examplecharts.CustomAngleCircle;
import com.webonlineapp.hyjavaapexdemo.examplecharts.CustomColorsTimeLine;
import com.webonlineapp.hyjavaapexdemo.examplecharts.CustomDataLabelsBar;
import com.webonlineapp.hyjavaapexdemo.examplecharts.DashedLine;
import com.webonlineapp.hyjavaapexdemo.examplecharts.DateTimeXAxis;
import com.webonlineapp.hyjavaapexdemo.examplecharts.DistributedColumns;
import com.webonlineapp.hyjavaapexdemo.examplecharts.DistributedTreemap;
import com.webonlineapp.hyjavaapexdemo.examplecharts.DonutWithPattern;
import com.webonlineapp.hyjavaapexdemo.examplecharts.GradientDonut;
import com.webonlineapp.hyjavaapexdemo.examplecharts.GradientLine;
import com.webonlineapp.hyjavaapexdemo.examplecharts.GradientRadial;
import com.webonlineapp.hyjavaapexdemo.examplecharts.GroupedBar;
import com.webonlineapp.hyjavaapexdemo.examplecharts.HorizontalBoxPlot;
import com.webonlineapp.hyjavaapexdemo.examplecharts.IrregularTimeSeriesArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.LineArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.LineChartWithAnnotations;
import com.webonlineapp.hyjavaapexdemo.examplecharts.LineColumn;
import com.webonlineapp.hyjavaapexdemo.examplecharts.LineColumnArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.LineScatter;
import com.webonlineapp.hyjavaapexdemo.examplecharts.LineWithDatalabels;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MissingNullValues;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MissingNullValuesArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MonochromePie;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MonochromePolarArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MultiColorsFlippedHeatmap;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MultiColorsHeatmap;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MultiDimensionalTreemap;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MultiSeriesTimeLine;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MultipleRadial;
import com.webonlineapp.hyjavaapexdemo.examplecharts.MultipleYAxis;
import com.webonlineapp.hyjavaapexdemo.examplecharts.NegativeArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.PatternedBar;
import com.webonlineapp.hyjavaapexdemo.examplecharts.RadarMultipleSeries;
import com.webonlineapp.hyjavaapexdemo.examplecharts.RadarWithPolygonFill;
import com.webonlineapp.hyjavaapexdemo.examplecharts.RealTime;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ReversedBarChart;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ScatterDateTime;
import com.webonlineapp.hyjavaapexdemo.examplecharts.SemiCircleGauge;
import com.webonlineapp.hyjavaapexdemo.examplecharts.SemiDonut;
import com.webonlineapp.hyjavaapexdemo.examplecharts.SimpleBubble;
import com.webonlineapp.hyjavaapexdemo.examplecharts.SimpleDonut;
import com.webonlineapp.hyjavaapexdemo.examplecharts.SimplePie;
import com.webonlineapp.hyjavaapexdemo.examplecharts.SplineArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.StackedArea;
import com.webonlineapp.hyjavaapexdemo.examplecharts.StackedBar;
import com.webonlineapp.hyjavaapexdemo.examplecharts.StackedBars100;
import com.webonlineapp.hyjavaapexdemo.examplecharts.StackedColumn;
import com.webonlineapp.hyjavaapexdemo.examplecharts.StackedColumn100;
import com.webonlineapp.hyjavaapexdemo.examplecharts.StepLine;
import com.webonlineapp.hyjavaapexdemo.examplecharts.StrokedGauge;
import com.webonlineapp.hyjavaapexdemo.examplecharts.SynchronizedCharts;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ThreeDBubble;
import com.webonlineapp.hyjavaapexdemo.examplecharts.ZoomableTimeSeries;

public class DemoCharts {

	private static final List<DemoChart> demoChartsList = new ArrayList<DemoChart>(Arrays.asList(
		new DemoChart("Line Charts"),
		new DemoChart("Basic", new BasicLine()),
		new DemoChart("Line With Datalabels", new LineWithDatalabels()),
		new DemoChart("Zoomable Time Series", new ZoomableTimeSeries()),
		new DemoChart("Line Chart With Annotations", new LineChartWithAnnotations()),
		new DemoChart("Synchronized Charts", new SynchronizedCharts()),
		new DemoChart("Brush Chart", new BrushChart()),
		new DemoChart("Step Line", new StepLine()),
		new DemoChart("Gradient Line", new GradientLine()),
		new DemoChart("Missing Null Values", new MissingNullValues()),
		new DemoChart("Real Time", new RealTime(), false),
		new DemoChart("Dashed", new DashedLine()),
		
		new DemoChart("Area charts"),
		new DemoChart("Basic", new BasicArea()),
		new DemoChart("Spline Area", new SplineArea()),
		new DemoChart("Date Time X-Axis", new DateTimeXAxis()),
		new DemoChart("Negative", new NegativeArea()),
		new DemoChart("Stacked", new StackedArea()),
		new DemoChart("Irregular Time Series", new IrregularTimeSeriesArea()),
		new DemoChart("Missing Null Values", new MissingNullValuesArea()),
		
		new DemoChart("Column charts"),
		new DemoChart("Basic", new BasicColumn()),
		new DemoChart("Column With Data Labels", new ColumnWithDataLabels()),
		new DemoChart("Stacked Columns", new StackedColumn()),
		new DemoChart("Stacked Columns 100", new StackedColumn100()),
		new DemoChart("Column With Rotated Labels", new ColumnWithRotatedLabels()),
		new DemoChart("Column With Negative Values", new ColumnWithNegativeValues()),
		new DemoChart("Distributed Columns", new DistributedColumns()),
		
		new DemoChart("Bar charts"),
		new DemoChart("Basic", new BasicBar()),
		new DemoChart("Grouped", new GroupedBar()),
		new DemoChart("Stacked", new StackedBar()),
		new DemoChart("Stacked Bars 100", new StackedBars100()),
		new DemoChart("Bar With Negative Values", new BarWithNegativeValues()),
		new DemoChart("Reversed Bar Chart", new ReversedBarChart()),
		new DemoChart("Custom Data Labels Bar", new CustomDataLabelsBar()),
		new DemoChart("Patterned", new PatternedBar()),
		
		new DemoChart("Mixed / Combo Charts"),
		new DemoChart("Line Column", new LineColumn()),
		new DemoChart("Multiple Y-Axis", new MultipleYAxis()),
		new DemoChart("Line and Area", new LineArea()),
		new DemoChart("Line Column Area", new LineColumnArea()),
		new DemoChart("Line Scatter", new LineScatter()),
		
		new DemoChart("Time Line Charts"),
		new DemoChart("Basic", new BasicTimeLine()),
		new DemoChart("Custom Colors", new CustomColorsTimeLine()),
		new DemoChart("Multi Series", new MultiSeriesTimeLine()),
		
		new DemoChart("Candlestick Charts"),
		new DemoChart("Basic", new BasicCandleStick()),
		new DemoChart("Combo", new ComboCandlestick()),
		new DemoChart("CandleStick With Line", new CandleStickWithLine()),
		
		new DemoChart("Box & Whisker Charts"),
		new DemoChart("Basic", new BasicBox()),
		new DemoChart("Boxplot Scatter", new BoxPlotScatter()),
		new DemoChart("Horizontal Box Plot", new HorizontalBoxPlot()),
		
		new DemoChart("Pie / Donuts"),
		new DemoChart("Simple Pie", new SimplePie()),
		new DemoChart("Simple Donut", new SimpleDonut()),
		new DemoChart("Monochrome Pie", new MonochromePie()),
		new DemoChart("Gradient Donut", new GradientDonut()),
		new DemoChart("Semi Donut", new SemiDonut()),
		new DemoChart("Donut With Pattern", new DonutWithPattern()),
		
		new DemoChart("Radar"),
		new DemoChart("Basic", new BasicRadar()),
		new DemoChart("Radar Multiple Series", new RadarMultipleSeries()),
		new DemoChart("Radar With Polygon Fill", new RadarWithPolygonFill()),
		
		new DemoChart("Polar Area"),
		new DemoChart("Basic", new BasicPolarArea()),
		new DemoChart("Monochrome", new MonochromePolarArea()),
		
		new DemoChart("Radial Bars / Circle Charts"),
		new DemoChart("Basic", new BasicRadial()),
		new DemoChart("Multiple", new MultipleRadial()),
		new DemoChart("Custom Angle Circle", new CustomAngleCircle()),
		new DemoChart("Gradient", new GradientRadial()),
		new DemoChart("Stroked Gauge", new StrokedGauge()),
		new DemoChart("Semi Circle Gauge", new SemiCircleGauge()),
		
		new DemoChart("Bubble Charts"),
		new DemoChart("Simple", new SimpleBubble()),
		new DemoChart("3D Bubble", new ThreeDBubble()),
		
		new DemoChart("Scatter Charts"),
		new DemoChart("Basic", new BasicScatter()),
		new DemoChart("Scatter Date Time", new ScatterDateTime()),
		
		new DemoChart("Heatmap Charts"),
		new DemoChart("Basic", new BasicHeatmap()),
		new DemoChart("Multi Colors for each Series", new MultiColorsHeatmap()),
		new DemoChart("Multi Colors Flipped", new MultiColorsFlippedHeatmap()),
		new DemoChart("Color Range", new ColorRangeHeatmap()),
		
		new DemoChart("Treemap Charts"),
		new DemoChart("Basic", new BasicTreemap()),
		new DemoChart("Color Scale", new ColorScaleTreemap()),
		new DemoChart("Distributed", new DistributedTreemap()),
		new DemoChart("Multi Dimensional", new MultiDimensionalTreemap())		

		));

	/**
	 * 
	 * @return
	 */
	public static final List<DemoChart> getDemoChartsList() {
		return demoChartsList;
	}


}
