package com.webonlineapp.hyjavaapexdemo.components;

import com.vaadin.flow.component.Component;
import com.vaadin.flow.component.HasComponents;
import com.vaadin.flow.component.HasSize;
import com.vaadin.flow.component.Tag;
import com.vaadin.flow.component.UI;
import com.vaadin.flow.component.dependency.JavaScript;
import com.vaadin.flow.component.page.Page;

@Tag("div")
@JavaScript("https://cdn.jsdelivr.net/npm/moment@2.28.0")
@JavaScript("https://cdn.jsdelivr.net/npm/apexcharts@3.33.2")
public class ApexchartComponent extends Component implements HasComponents, HasSize {
	private static final long serialVersionUID = 806054527112127036L;
	
	private static long chartId = 1;
	
	
	/**
	 * 
	 */
	public ApexchartComponent() { 
		//UI.getCurrent().getPage().addJavaScript(ServletUtil.getContextPath() + "/js/apexcharts.min.js");
		//UI.getCurrent().getPage().addJavaScript(ServletUtil.getContextPath() + "/js/moment.min.js");

        setId("apex_" + getNextChartId());
        getElement().setAttribute("class", "chart");
 	}

	/**
	 * 
	 * @param chartOptions
	 */
	public void displayChart(String chartOptions) {
		Page page = UI.getCurrent().getPage();
    	
    	String chartOptionsJs = "var chart = new ApexCharts(document.querySelector(\"#" + 
    			getId().get() + "\"), " + chartOptions + ");" + "chart.render();";
    	
    	page.executeJs(chartOptionsJs);
	}
	
	/**
	 * 
	 * @return
	 */
	private long getNextChartId() {
		chartId++;
		
		if (chartId > 10000) {
			chartId = 1;
		}
		
		return chartId;
	}
	
}
