package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.StartEndShape;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BasicColumn extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BAR);
		
		chartOptions.getPlotOptions().getBar()
			.setHorizontal(false).setColumnWidth("55%").setEndingShape(StartEndShape.ROUNDED);
		
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setShow(true).setWidth(2).getColors().add(new Color("transparent"));

		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList("Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct"));
		chartOptions.getYaxisSingle().getTitle().setText("$ (thousands)");
		
		chartOptions.getFill().setOpacity(1);
		chartOptions.getTooltip().getY().setFormatter(new Function("return \"$ \" + val + \" thousands\"", "val"));
		
		Series series = new Series();
		series.setName("Net Profit");
		series.setDataAsArrayNumber(Arrays.asList(44, 55, 57, 56, 61, 58, 63, 60, 66));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Revenue");
		series.setDataAsArrayNumber(Arrays.asList(76, 85, 101, 98, 87, 105, 91, 114, 94));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Free Cash Flow");
		series.setDataAsArrayNumber(Arrays.asList(35, 41, 36, 26, 45, 48, 52, 53, 41));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}