package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.plotoptions.treemap.colorscale.Ranges;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ColorScaleTreemap extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.TREEMAP);
		chartOptions.getLegend().setShow(false);
		chartOptions.getTitle().setText("Treemap with Color scale");
		
		chartOptions.getDataLabels().setEnabled(true)
			.setFormatter(new Function("return [text, op.value]", "text", "op"))
			.setOffsetY(-4)
			.getStyle().setFontSize("12px");
		
		chartOptions.getPlotOptions().getTreemap()
			.setEnableShades(true).setShadeIntensity(0.5).setReverseNegativeShade(true);
		chartOptions.getPlotOptions().getTreemap().getColorScale()
			.setRanges(Arrays.asList(
				new Ranges().setFrom(-6).setTo(0).setColor(new Color("#CD363A")),
				new Ranges().setFrom(0.001).setTo(6).setColor(new Color("#52B12C"))));

		chartOptions.getSeries().add(new Series().setDataAsArrayObject(getData()));


		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private List<Data> getData() {
		return Arrays.asList(
			new Data().setX("INTC").setY(1.2), new Data().setX("GS").setY(0.4), 
			new Data().setX("CVX").setY(-1.4), new Data().setX("GE").setY(2.7), 
			new Data().setX("CAT").setY(-0.3), new Data().setX("RTX").setY(5.1), 
			new Data().setX("CSCO").setY(-2.3), new Data().setX("JNJ").setY(2.1), 
			new Data().setX("PG").setY(0.3), new Data().setX("TRV").setY(0.12), 
			new Data().setX("MMM").setY(-2.31), new Data().setX("NKE").setY(3.98), 
			new Data().setX("IYT").setY(1.67));
	}
	
}
