package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisPosition;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.CrosshairsFillType;
import com.hyjavaapex.model.apexcharts.constants.DataLabelsPosition;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ColumnWithDataLabels extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BAR);
		
		chartOptions.getPlotOptions().getBar().getDataLabels().setPosition(DataLabelsPosition.TOP);
		chartOptions.getDataLabels().setEnabled(true).setOffsetY(-20)
			.setFormatter(new Function("return val + \"%\";", "val"))
			.getStyle().setFontSize("12px").setColorsAsArrayColor(Arrays.asList(new Color("#304758")));

		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"))
			.setPosition(AxisPosition.TOP);
		
		chartOptions.getXaxis().getAxisBorder().setShow(false);
		chartOptions.getXaxis().getAxisTicks().setShow(false);
		chartOptions.getXaxis().getCrosshairs().getFill().setType(CrosshairsFillType.GRADIENT)
			.getGradient().setColorFrom(new Color("#D8E3F0")).setColorTo(new Color("#BED1E6"))
			.setStops(Arrays.asList(0, 100)).setOpacityFrom(0.4).setOpacityTo(0.5);
		chartOptions.getXaxis().getTooltip().setEnabled(true);
		
		chartOptions.getYaxisSingle().getAxisBorder().setShow(false);
		chartOptions.getYaxisSingle().getAxisTicks().setShow(false);
		chartOptions.getYaxisSingle().getLabels().setShow(false)
			.setFormatter(new Function("return val + \"%\";", "val"));

		chartOptions.getTitle().setText("Monthly Inflation in Argentina, 2002")
			.setFloating(true).setOffsetY(430).setAlign(HorizontalAlign.CENTER)
			.getStyle().setColor(new Color("#444"));
		
		Series series = new Series();
		series.setName("Inflation");
		series.setDataAsArrayNumber(Arrays.asList(2.3, 3.1, 4.0, 10.1, 4.0, 3.6, 3.2, 2.3, 1.4, 0.8, 0.5, 0.2));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}