package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AutoSelected;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.chartdata.ComboCandlestickData;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ComboCandlestick extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;
	private int chartid = 0;


	public Apexchart candlestickChartConfigure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(290).setType(ChartType.CANDLESTICK)
			.setId("candles" + chartid)
			.getToolbar().setAutoSelected(AutoSelected.PAN).setShow(false);
		chartOptions.getChart().getZoom().setEnabled(false);
		
		chartOptions.getPlotOptions().getCandlestick()
			.getColors().setUpward(new Color("#3C90EB")).setDownward(new Color("#DF7D46"));
		
		chartOptions.getXaxis().setType(AxisType.DATETIME);
		
		Series series = new Series();
		series.getDataAsJsValue().setJsValue(new ComboCandlestickData().getSeriesData());
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
		
	/**
	 * 
	 * @return
	 */
	public Apexchart barChartConfigure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();

		chartOptions.getChart().setHeight(160).setType(ChartType.BAR)
			.getBrush().setTarget("candles" + chartid).setEnabled(true);
		
		chartOptions.getChart().getSelection().setEnabled(true)
			.getXaxis().setMin(new Date("20 Jan 2017").getTime()).setMax(new Date("10 Dec 2017").getTime());
		
		chartOptions.getChart().getSelection().getFill().setColor(new Color("#ccc")).setOpacity(0.4);
		chartOptions.getChart().getSelection().getStroke().setColor(new Color("#0D47A1"));
		
		chartOptions.getDataLabels().setEnabled(false);

		chartOptions.getPlotOptions().getBar().setColumnWidth("80%")
			.getColors().getRangesSingle().setFrom(1).setTo(10000).setColor(new Color("#FEB019"));

		chartOptions.getStroke().setWidth(0);

		chartOptions.getXaxis().setType(AxisType.DATETIME).getAxisBorder().setOffsetX(13);
		chartOptions.getYaxisSingle().getLabels().setShow(false);
		
		Series series = new Series();
		series.getDataAsJsValue().setJsValue(new ComboCandlestickData().getSeriesDataLinear());
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
	/**
	 * 
	 */
	public List<Apexchart> getCharts() {
		List<Apexchart> chartList = new ArrayList<Apexchart>();
		
		chartid++;
		chartList.add(candlestickChartConfigure());
		chartList.add(barChartConfigure());
		
		return chartList;
	}
	
}