package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;
import java.util.Date;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.MarkerShape;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.General;
import com.webonlineapp.hyjavaapexdemo.chartdata.StockCloseData;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class DateTimeXAxis extends DemoChartBase {
	private static final long serialVersionUID = 5742682049052371583L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.AREA).setId("area-datetime")
			.getZoom().setAutoScaleYaxis(true);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getMarkers().setSize(0).setShape(MarkerShape.CIRCLE);	// style: 'hollow', not in api
		
		chartOptions.getXaxis().setType(AxisType.DATETIME)
			.setMin(new Date("01 Mar 2012").getTime()).setTickAmount(6);
		
		chartOptions.getTooltip().getX().setFormat("dd MMM yyyy");
		chartOptions.getFill().setType(FillType.GRADIENT).getGradient()
			.setShadeIntensity(1).setOpacityFrom(0.7).setOpacityTo(0.9).setStops(Arrays.asList(0, 100));

		chartOptions.getAnnotations().getYaxisSingle()
			.setY(30).setBorderColor(new Color("#999"))
			.getLabel().setText("Support")
			.getStyle().setColor(new Color("#fff")).setBackground(new Color("#00E396"));
		chartOptions.getAnnotations().getXaxisSingle()
			.setX(new Date("14 Nov 2012").getTime()).setBorderColor(new Color("#999"))
			.getLabel().setText("Rally")
			.getStyle().setColor(new Color("#fff")).setBackground(new Color("#775DD0"));
		
		Series series = new Series();
		series.setData(new General(new StockCloseData().get()));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}