package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class GradientDonut extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.DONUT);
		
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getFill().setType(FillType.GRADIENT);

		chartOptions.getLegend().setFormatter(
			new Function("return val + \" - \" + opts.w.globals.series[opts.seriesIndex]", "val", "opts"));
		
		chartOptions.getResponsiveSingle().setBreakpoint(480).getOptions().getChart().setWidth(200);
		chartOptions.getResponsiveSingle().getOptions().getLegend().setPosition(LegendPosition.BOTTOM);
		
		chartOptions.setSeriesAsArrayNumber(Arrays.asList(44, 55, 41, 17, 15));

		return apexchart;
	}

}