package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.GradientType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.Shade;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class GradientLine extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.LINE);
		chartOptions.getStroke().setWidth(7).setCurve(Curve.SMOOTH);

		chartOptions.getTitle().setText("Social Media").setAlign(HorizontalAlign.LEFT)
			.getStyle().setFontSize("16px").setColor(new Color("#666"));
		
		chartOptions.getXaxis().setType(AxisType.DATETIME)
			.setCategoriesAsArrayString(Arrays.asList(
				"1/11/2000", "2/11/2000", "3/11/2000", "4/11/2000", "5/11/2000", "6/11/2000", 
				"7/11/2000", "8/11/2000", "9/11/2000", "10/11/2000", "11/11/2000", "12/11/2000", 
				"1/11/2001", "2/11/2001", "3/11/2001","4/11/2001" ,"5/11/2001" ,"6/11/2001"));
		
		chartOptions.getFill().setType(FillType.GRADIENT)
			.getGradient().setShade(Shade.DARK).setGradientToColors(Arrays.asList(new Color("#FDD835")))
			.setShadeIntensity(1).setType(GradientType.HORIZONTAL)
			.setOpacityFrom(1).setOpacityTo(1).setStops(Arrays.asList(0, 100, 100, 100));
		
		chartOptions.getMarkers().setSize(4).setColors(Arrays.asList(new Color("#FFA41B"))).setStrokeWidth(2)
			.getHover().setSize(7);
		
		chartOptions.getYaxisSingle().setMin(-10).setMax(40).getTitle().setText("Engagement");
		
		Series series = new Series();
		series.setName("Likes");
		series.setDataAsArrayNumber(Arrays.asList(4, 3, 10, 9, 29, 19, 22, 9, 12, 7, 19, 5, 13, 9, 17, 2, 7, 5));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}