package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class HorizontalBoxPlot extends DemoChartBase {
	private static final long serialVersionUID = 6708470508964497570L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BOXPLOT);
		chartOptions.getTitle().setText("Horizontal BoxPlot Chart").setAlign(HorizontalAlign.LEFT);
	          
		chartOptions.getPlotOptions()
			.getBar().setHorizontal(true).setBarHeight("50%");
		chartOptions.getPlotOptions()
			.getBoxPlot().getColors().setUpper(new Color("#e9ecef")).setLower(new Color("#f8f9fa"));

		chartOptions.getStroke().setColors(Arrays.asList(new Color("#6c757d")));
		
		Series series = new Series();
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX("Category A").setY(Arrays.asList(54, 66, 69, 75, 88)),
				new Data().setX("Category B").setY(Arrays.asList(43, 65, 69, 76, 81)),
				new Data().setX("Category C").setY(Arrays.asList(31, 39, 45, 51, 59)),
				new Data().setX("Category D").setY(Arrays.asList(39, 46, 55, 65, 71)),
				new Data().setX("Category E").setY(Arrays.asList(29, 31, 35, 39, 44)),
				new Data().setX("Category F").setY(Arrays.asList(41, 49, 58, 61, 67)),
				new Data().setX("Category G").setY(Arrays.asList(54, 59, 66, 71, 88))
				));
		
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}