package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.hyjavaapex.model.common.Pair;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class IrregularTimeSeriesArea extends DemoChartBase {
	private static final long serialVersionUID = 5742682049052371583L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.AREA).setStacked(false)
			.getZoom().setEnabled(false);
		
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getMarkers().setSize(0);

		chartOptions.getFill().setType(FillType.GRADIENT)
			.getGradient().setShadeIntensity(1).setInverseColors(false)
			.setOpacityFrom(0.45).setOpacityTo(0.05)
			.setStops(Arrays.asList(20, 100, 100, 100));

		chartOptions.getYaxisSingle().getLabels().setOffsetX(0)
			.setFormatter(new Function("return (val / 1000000).toFixed(2);", "val"))
			.getStyle().setColors(new Color("#8e8da4"));
		chartOptions.getYaxisSingle().getAxisBorder().setShow(false);
		chartOptions.getYaxisSingle().getAxisTicks().setShow(false);

		chartOptions.getXaxis().setType(AxisType.DATETIME).setTickAmount(8)
			.setMin(new Date("01/01/2014").getTime()).setMax(new Date("01/20/2014").getTime())
			.getLabels().setRotate(-15).setRotateAlways(true)
			.setFormatter(
					new Function("return moment(new Date(timestamp)).format(\"DD MMM YYYY\")", "val", "timestamp"));

		chartOptions.getTitle().setText("Irregular Data in Time Series")
			.setAlign(HorizontalAlign.LEFT).setOffsetX(14);
		
		chartOptions.getTooltip().setShared(true);
		chartOptions.getLegend().setPosition(LegendPosition.TOP)
			.setHorizontalAlign(HorizontalAlign.RIGHT).setOffsetX(-10);
		
		Series series = new Series();
		series.setName("PRODUCT A");
		series.setDataAsArrayPairs(getData(1, 1388534400000L, 12));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("PRODUCT B");
		series.setDataAsArrayPairs(getData(2, 1388620800000L, 18));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("PRODUCT C");
		series.setDataAsArrayPairs(getData(3, 1389052800000L, 12));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
/**
 * 
 * @param series
 * @param time
 * @param count
 * @return
 */
	private List<Pair> getData(int series, Long time, int count) {
		List<Number> prices3 = Arrays.asList(20000000, 10379978, 30493749, 10785250, 33901904, 11576838, 14413854, 15177211, 16622100, 17381072, 18802310, 15531790, 15748881, 18706437, 19752685, 21016418, 25622924, 25337480, 22258882, 23829538, 24245689, 26429711, 26259017, 25396183, 23107346, 28659852, 25270783, 26270783, 27270783, 28270783, 29270783, 30270783, 31270783, 32270783, 33270783, 28270783, 27270783, 35270783, 34270783, 28270783, 35270783, 36270783, 34127078, 33124078, 36227078, 37827078, 36427073, 37570783, 38627073, 37727078, 38827073, 40927078, 41027078, 42127073, 43220783, 44327078, 40427078, 41027078, 45627078, 44727078, 44227078, 45227078, 46027078, 46927078, 47027078, 46227078, 47027078, 48027078, 47027078, 47027078, 48017078, 48077078, 48087078, 48017078, 48047078, 48067078, 48077078, 48027074, 48927079, 48727071, 48127072, 48527072, 48627027, 48027040, 48027043, 48057022, 49057022, 50057022, 51057022, 52057022, 53057022, 54057022, 52057022, 55057022, 58270783, 56270783, 55270783, 58270783, 59270783, 60270783, 61270783, 62270783, 63270783, 64270783, 65270783, 66270783, 67270783, 68270783, 69270783, 70270783, 71270783, 72270783, 73270783, 74270783, 75270783, 76660783, 77270783, 78370783, 79470783, 80170783);
		List<Number> prices2 = Arrays.asList(150000000, 160379978, 170493749, 160785250, 167391904, 161576838, 161413854, 152177211, 140762210, 144381072, 154352310, 165531790, 175748881, 187064037, 197520685, 210176418, 196122924, 207337480, 200258882, 186829538, 192456897, 204299711, 192759017, 203596183, 208107346, 196359852, 192570783, 177967768, 190632803, 203725316, 218226177, 210698669, 217640656, 216142362, 201410971, 196704289, 190436945, 178891686, 171613962, 157579773, 158677098, 147129977, 151561876, 151627421, 143543872, 136581057, 135560715, 122625263, 112091484, 98810329, 99882912, 94943095, 104875743, 116383678, 125028841, 123967310, 133167029, 128577263, 115836969, 119264529, 109363374, 113985628, 114650999, 110866108, 96473454, 104075886, 103568384, 101534883, 115825447, 126133916, 116502109, 130169411, 124296886, 126347399, 131483669, 142811333, 129675396, 115514483, 117630630, 122340239, 132349091, 125613305, 135592466, 123408762, 111991454, 116123955, 112817214, 113029590, 108753398, 99383763, 100151737, 94985209, 82913669, 78748268, 63829135, 78694727, 80868994, 93799013, 99042416, 97298692, 83353499, 71248129, 75253744, 68976648, 71002284, 75052401, 83894030, 90236528, 99739114, 96407136, 108323177, 101578914, 115877608, 112088857, 112071353, 101790062, 115003761, 120457727, 118253926, 117956992);
		List<Number> prices1 = Arrays.asList(50000000, 60379978, 40493749, 60785250, 67391904, 61576838, 61413854, 82177211, 103762210, 84381072, 54352310, 65531790, 75748881, 47064037, 67520685, 60176418, 66122924, 57337480, 100258882, 46829538, 92456897, 94299711, 62759017, 103596183, 108107346, 66359852, 62570783, 77967768, 60632803, 103725316, 98226177, 60698669, 67640656, 66142362, 101410971, 66704289, 60436945, 78891686, 71613962, 107579773, 58677098, 87129977, 51561876, 51627421, 83543872, 66581057, 65560715, 62625263, 92091484, 48810329, 49882912, 44943095, 104875743, 96383678, 105028841, 63967310, 63167029, 68577263, 95836969, 99264529, 109363374, 93985628, 94650999, 90866108, 46473454, 84075886, 103568384, 101534883, 95825447, 66133916, 96502109, 80169411, 84296886, 86347399, 31483669, 82811333, 89675396, 95514483, 97630630, 62340239, 62349091, 65613305, 65592466, 63408762, 91991454, 96123955, 92817214, 93029590, 108753398, 49383763, 100151737, 44985209, 52913669, 48748268, 23829135, 58694727, 50868994, 43799013, 4042416, 47298692, 53353499, 71248129, 75253744, 68976648, 71002284, 75052401, 83894030, 50236528, 59739114, 56407136, 108323177, 101578914, 95877608, 62088857, 92071353, 81790062, 105003761, 100457727, 98253926, 67956992);
				
		List<Pair> data = new ArrayList<Pair>();
		
		for (int i = 0; i < count; i++) {
			time += 86400000;
			
			if (series == 1) {
				data.add(new Pair(time, prices1.get(i)));
			}
			else if (series == 2) {
				data.add(new Pair(time, prices2.get(i)));
			}
			else {
				data.add(new Pair(time, prices3.get(i)));
			}
		}
		
		return data;
	}
	
}
