package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.SeriesType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class LineScatter extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.LINE);
		chartOptions.getFill().setType(FillType.SOLID);
		chartOptions.getMarkers().setSize(Arrays.asList(6, 0));
		
		chartOptions.getTooltip().setShared(true).setIntersect(false);
		chartOptions.getLegend().setShow(false);

		chartOptions.getXaxis().setType(AxisType.NUMERIC).setMin(0).setMax(12).setTickAmount(12);
		
		Series series = new Series();
		series.setName("Points").setType(SeriesType.SCATTER);
		series.setDataAsArrayObject(getData(1));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Line").setType(SeriesType.LINE);
		series.setDataAsArrayObject(getData(2));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
	/**
	 * 
	 * @param series
	 * @return
	 */
	private List<Data> getData(int series) {
		if (series == 1) {
			return Arrays.asList(
					new Data().setX(1).setY(2.14), 
					new Data().setX(1.2).setY(2.19), 
					new Data().setX(1.8).setY(2.43), 
					new Data().setX(2.3).setY(3.8), 
					new Data().setX(2.6).setY(4.14), 
					new Data().setX(2.9).setY(5.4), 
					new Data().setX(3.2).setY(5.8), 
					new Data().setX(3.8).setY(6.04), 
					new Data().setX(4.55).setY(6.77), 
					new Data().setX(4.9).setY(8.1), 
					new Data().setX(5.1).setY(9.4), 
					new Data().setX(7.1).setY(7.14),
					new Data().setX(9.18).setY(8.4));
		}
		else {
			return Arrays.asList(
					new Data().setX(1).setY(2), 
					new Data().setX(2).setY(3), 
					new Data().setX(3).setY(4), 
					new Data().setX(4).setY(5), 
					new Data().setX(5).setY(6), 
					new Data().setX(6).setY(7), 
					new Data().setX(7).setY(8), 
					new Data().setX(8).setY(9), 
					new Data().setX(9).setY(10), 
					new Data().setX(10).setY(11));
		}
	}
	
}