package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.Palette;
import com.hyjavaapex.model.apexcharts.constants.Style;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.NullOption;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class MissingNullValuesArea extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.AREA)
			.getAnimations().setEnabled(false);
		chartOptions.getChart().getZoom().setEnabled(false);
		chartOptions.getDataLabels().setEnabled(false);
		
		chartOptions.getStroke().setCurve(Curve.STRAIGHT);
		chartOptions.getFill().setOpacity(0.8).setType(FillType.PATTERN)
			.getPattern().setStyle(Arrays.asList(Style.VERTICALLINES, Style.HORIZONTALLINES))
				.setWidth(5).setHeight(6);
		
		chartOptions.getMarkers().setSize(5).getHover().setSize(9);
		chartOptions.getTitle().setText("Network Monitoring");
		
		chartOptions.getTooltip().setIntersect(true).setShared(false);
		chartOptions.getTheme().setPalette(Palette.PALETTE1);

		chartOptions.getXaxis().setType(AxisType.DATETIME);
		chartOptions.getYaxisSingle().getTitle().setText("Bytes Received");
		
		Series series = new Series();
		series.setName("Network");
		series.setDataAsArrayObject(getData());
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private List<Data> getData() {
		return Arrays.asList(new Data().setX("Dec 23 2017").setY(NullOption.NULL_NUMBER), new Data().setX("Dec 24 2017").setY(44), new Data().setX("Dec 25 2017").setY(31), new Data().setX("Dec 26 2017").setY(38), new Data().setX("Dec 27 2017").setY(NullOption.NULL_NUMBER), new Data().setX("Dec 28 2017").setY(32), new Data().setX("Dec 29 2017").setY(55), new Data().setX("Dec 30 2017").setY(51), new Data().setX("Dec 31 2017").setY(67), new Data().setX("Jan 01 2018").setY(22), new Data().setX("Jan 02 2018").setY(34), new Data().setX("Jan 03 2018").setY(NullOption.NULL_NUMBER), new Data().setX("Jan 04 2018").setY(NullOption.NULL_NUMBER), new Data().setX("Jan 05 2018").setY(11), new Data().setX("Jan 06 2018").setY(4), new Data().setX("Jan 07 2018").setY(15), new Data().setX("Jan 08 2018").setY(NullOption.NULL_NUMBER), new Data().setX("Jan 09 2018").setY(9), new Data().setX("Jan 10 2018").setY(34), new Data().setX("Jan 11 2018").setY(NullOption.NULL_NUMBER), new Data().setX("Jan 12 2018").setY(NullOption.NULL_NUMBER), new Data().setX("Jan 13 2018").setY(13), new Data().setX("Jan 14 2018").setY(NullOption.NULL_NUMBER));
	}
	
}