package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class MonochromePie extends DemoChartBase {
	private static final long serialVersionUID = -6445998022722629903L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setWidth("100%").setType(ChartType.PIE);
		chartOptions.getTitle().setText("Monochrome Pie");
		
		chartOptions.setLabels(Arrays.asList("Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"));
		chartOptions.getTheme().getMonochrome().setEnabled(true);
		
		chartOptions.getPlotOptions().getPie().getDataLabels().setOffset(-5);
		
		chartOptions.getDataLabels().setFormatter(
				new Function("const name = opts.w.globals.labels[opts.seriesIndex]; return [name, val.toFixed(1) + '%'];",
							 "val, opts"));
		
		chartOptions.getLegend().setShow(false);
		
		chartOptions.setSeriesAsArrayNumber(Arrays.asList(25, 15, 44, 55, 41, 17));

		return apexchart;
	}
	
}