package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class MultiDimensionalTreemap extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.TREEMAP);
		chartOptions.getLegend().setShow(false);
		chartOptions.getTitle().setText("Multi-dimensional Treemap").setAlign(HorizontalAlign.CENTER);

		chartOptions.getSeries().add(new Series().setName("Desktops")
			.setDataAsArrayObject(Arrays.asList(new Data().setX("ABC").setY(10), 
												new Data().setX("DEF").setY(60), 
												new Data().setX("XYZ").setY(41))));
		
		chartOptions.getSeries().add(new Series().setName("Desktops")
			.setDataAsArrayObject(Arrays.asList(new Data().setX("ABCD").setY(10), 
												new Data().setX("DEFG").setY(20), 
												new Data().setX("WXYZ").setY(51),
												new Data().setX("PQR").setY(30), 
												new Data().setX("MNO").setY(20), 
												new Data().setX("CDE").setY(30))));

		return apexchart;
	}
	
}