package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.TooltipPosition;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class NegativeArea extends DemoChartBase {
	private static final long serialVersionUID = 5742682049052371583L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.AREA);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setCurve(Curve.STRAIGHT);
		
		chartOptions.getTitle().setText("Area with Negative Values").setAlign(HorizontalAlign.LEFT)
			.getStyle().setFontSize("14px");
		
		chartOptions.getXaxis().setType(AxisType.DATETIME).getAxisBorder().setShow(false);
		chartOptions.getXaxis().getAxisTicks().setShow(false);
		
		chartOptions.getYaxisSingle().setTickAmount(4).setFloating(false)
			.getLabels().setOffsetY(-7).setOffsetX(0).getStyle().setColors(new Color("#8e8da4"));
		chartOptions.getYaxisSingle().getAxisBorder().setShow(false);
		chartOptions.getYaxisSingle().getAxisTicks().setShow(false);
		
		chartOptions.getFill().setOpacity(0.5);
		chartOptions.getTooltip().getX().setFormat("yyyy");
		chartOptions.getTooltip().getFixed().setEnabled(false).setPosition(TooltipPosition.TOPRIGHT);

		chartOptions.getGrid().getYaxis().getLines().setOffsetX(-30);
		chartOptions.getGrid().getPadding().setLeft(20);
		
		Series series = new Series();
		series.setName("north");
		series.setDataAsArrayObject(getData(1));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("south");
		series.setDataAsArrayObject(getData(2));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
	/**
	 * 
	 * @param id
	 * @return
	 */
	private List<Data> getData(int id) {
		if (id == 1) {
			return Arrays.asList(
					new Data().setX(1996).setY(322), 
		            new Data().setX(1997).setY(324), 
		            new Data().setX(1998).setY(329), 
		            new Data().setX(1999).setY(342), 
		            new Data().setX(2000).setY(348), 
		            new Data().setX(2001).setY(334), 
		            new Data().setX(2002).setY(325), 
		            new Data().setX(2003).setY(316), 
		            new Data().setX(2004).setY(318), 
		            new Data().setX(2005).setY(330), 
		            new Data().setX(2006).setY(355), 
		            new Data().setX(2007).setY(366), 
		            new Data().setX(2008).setY(337), 
		            new Data().setX(2009).setY(352), 
		            new Data().setX(2010).setY(377), 
		            new Data().setX(2011).setY(383), 
		            new Data().setX(2012).setY(344), 
		            new Data().setX(2013).setY(366), 
		            new Data().setX(2014).setY(389), 
		            new Data().setX(2015).setY(334));
		}
		else {
			return Arrays.asList(
					new Data().setX(1996).setY(162), 
		            new Data().setX(1997).setY(90), 
		            new Data().setX(1998).setY(50), 
		            new Data().setX(1999).setY(77), 
		            new Data().setX(2000).setY(35), 
		            new Data().setX(2001).setY(-45), 
		            new Data().setX(2002).setY(-88), 
		            new Data().setX(2003).setY(-120), 
		            new Data().setX(2004).setY(-156), 
		            new Data().setX(2005).setY(-123), 
		            new Data().setX(2006).setY(-88), 
		            new Data().setX(2007).setY(-66), 
		            new Data().setX(2008).setY(-45), 
		            new Data().setX(2009).setY(-29), 
		            new Data().setX(2010).setY(-45), 
		            new Data().setX(2011).setY(-88), 
		            new Data().setX(2012).setY(-132), 
		            new Data().setX(2013).setY(-146), 
		            new Data().setX(2014).setY(-169), 
		            new Data().setX(2015).setY(-184));
		}
	}
	
}