package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.FilterType;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.apexcharts.constants.Style;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class PatternedBar extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();

		chartOptions.getChart().setHeight(450).setType(ChartType.BAR).setStacked(true)
			.getDropShadow().setEnabled(true).setBlur(1).setOpacity(0.25);
		
		chartOptions.getPlotOptions().getBar().setBarHeight("60%").setHorizontal(true);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setWidth(2);
		
		chartOptions.getTitle().setText("Compare Sales Strategy");

		chartOptions.getXaxis()
			.setCategoriesAsArrayNumber(Arrays.asList(2008, 2009, 2010, 2011, 2012, 2013, 2014));
		
		chartOptions.getTooltip().setShared(false).getY().setFormatter(new Function("return val + \"K\"", "val"));

		chartOptions.getFill().setType(FillType.PATTERN).setOpacity(1).getPattern().setStyle(
			Arrays.asList(Style.CIRCLES, Style.SLANTEDLINES, Style.VERTICALLINES, Style.HORIZONTALLINES));

		chartOptions.getStates().getHover().getFilter().setType(FilterType.NONE);

		chartOptions.getLegend().setPosition(LegendPosition.RIGHT).setOffsetY(40);
		
		Series series = new Series();
		series.setName("Marine Sprite").setDataAsArrayNumber(Arrays.asList(44, 55, 41, 37, 22, 43, 21));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Striking Calf").setDataAsArrayNumber(Arrays.asList(53, 32, 33, 52, 13, 43, 32));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Tank Picture").setDataAsArrayNumber(Arrays.asList(12, 17, 11, 9, 15, 11, 20));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Bucket Slope").setDataAsArrayNumber(Arrays.asList(9, 7, 5, 8, 6, 9, 4));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}