package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.SeriesType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BasicBox extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BOXPLOT);
		chartOptions.getTitle().setText("Basic BoxPlot Chart").setAlign(HorizontalAlign.LEFT);
	          
		chartOptions.getPlotOptions().getBoxPlot()
			.getColors().setUpper(new Color("#5C4742")).setLower(new Color("#A5978B"));
		
		Series series = new Series();
		series.setType(SeriesType.BOXPLOT);
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX("Jan 2015").setY(Arrays.asList(54, 66, 69, 75, 88)),
				new Data().setX("Jan 2016").setY(Arrays.asList(43, 65, 69, 76, 81)),
				new Data().setX("Jan 2017").setY(Arrays.asList(31, 39, 45, 51, 59)),
				new Data().setX("Jan 2018").setY(Arrays.asList(39, 46, 55, 65, 71)),
				new Data().setX("Jan 2019").setY(Arrays.asList(29, 31, 35, 39, 44)),
				new Data().setX("Jan 2020").setY(Arrays.asList(41, 49, 58, 61, 67)),
				new Data().setX("Jan 2021").setY(Arrays.asList(54, 59, 66, 71, 88))
				));
		
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}