package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;
import java.util.Date;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BasicTimeLine extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.RANGEBAR);
		chartOptions.getPlotOptions().getBar().setHorizontal(true);
		
		chartOptions.getXaxis().setType(AxisType.DATETIME);

		chartOptions.getSeries().add(getData());

		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private Series getData() {
		Series series = new Series();;
		
		series.setDataAsArrayObject(Arrays.asList(
			new Data().setX("Code") 
					  .setY(Arrays.asList(new Date("2019/03/02").getTime(), new Date("2019/03/04").getTime())),
			new Data().setX("Test")
					  .setY(Arrays.asList(new Date("2019/03/04").getTime(), new Date("2019/03/08").getTime())),
			new Data().setX("Validation")
					  .setY(Arrays.asList(new Date("2019/03/08").getTime(), new Date("2019/03/12").getTime())),
			new Data().setX("Deployment")
					  .setY(Arrays.asList(new Date("2019/03/12").getTime(), new Date("2019/03/18").getTime()))
				));
		
		return series;
	}
	
}