package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;
import java.util.Date;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.SeriesType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BoxPlotScatter extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BOXPLOT);
		chartOptions.getTitle().setText("BoxPlot - Scatter Chart").setAlign(HorizontalAlign.LEFT);
		chartOptions.setColors(Arrays.asList(new Color("#008FFB"), new Color("#FEB019")));
		
		chartOptions.getXaxis().setType(AxisType.DATETIME)
			.getTooltip().setFormatter(new Function("return new Date(val).getFullYear()", "val"));

		chartOptions.getTooltip().setShared(false).setIntersect(true);

		Series series = new Series();
		series.setType(SeriesType.BOXPLOT).setName("box");
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX(new Date("2017/01/01").getTime()).setY(Arrays.asList(54, 66, 69, 75, 88)),
				new Data().setX(new Date("2018/01/01").getTime()).setY(Arrays.asList(43, 65, 69, 76, 81)),
				new Data().setX(new Date("2019/01/01").getTime()).setY(Arrays.asList(31, 39, 45, 51, 59)),
				new Data().setX(new Date("2020/01/01").getTime()).setY(Arrays.asList(39, 46, 55, 65, 71)),
				new Data().setX(new Date("2021/01/01").getTime()).setY(Arrays.asList(29, 31, 35, 39, 44))
				));
		
		chartOptions.getSeries().add(series);

		series = new Series();
		series.setType(SeriesType.SCATTER).setName("outliers");
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX(new Date("2017/01/01").getTime()).setY(32),
				new Data().setX(new Date("2018/01/01").getTime()).setY(25),
				new Data().setX(new Date("2019/01/01").getTime()).setY(64),
				new Data().setX(new Date("2020/01/01").getTime()).setY(27),
				new Data().setX(new Date("2020/01/01").getTime()).setY(78),
				new Data().setX(new Date("2021/01/01").getTime()).setY(15)
				));
		
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}