package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.plotoptions.heatmap.colorscale.Ranges;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ColorRangeHeatmap extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.HEATMAP);
		chartOptions.getDataLabels().setEnabled(false);
		
		chartOptions.getPlotOptions().getHeatmap()
			.setShadeIntensity(0.5).setRadius(0).setUseFillColorAsStroke(true);
		
		chartOptions.getPlotOptions().getHeatmap().getColorScale().getRanges()
			.add(new Ranges().setFrom(-30).setTo(5).setName("low").setColor(new Color("#00A100")));
		chartOptions.getPlotOptions().getHeatmap().getColorScale().getRanges()
			.add(new Ranges().setFrom(6).setTo(20).setName("medium").setColor(new Color("#128FD9")));
		chartOptions.getPlotOptions().getHeatmap().getColorScale().getRanges()
			.add(new Ranges().setFrom(21).setTo(45).setName("high").setColor(new Color("#FFB200")));
		chartOptions.getPlotOptions().getHeatmap().getColorScale().getRanges()
			.add(new Ranges().setFrom(46).setTo(55).setName("extreme").setColor(new Color("#FF0000")));
		
		chartOptions.getStroke().setWidth(1);
		chartOptions.getTitle().setText("HeatMap Chart with Color Range");
		
		String[] month = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep"};
		for (int i = 0; i < 9; i++) {
			chartOptions.getSeries().add(getData().setName(month[i]));
		}

		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private Series getData() {
		int countMax = 20;
		int yRangeMin = -30;
		int yRangeMax = 55;
		
		Series series = new Series();
		List<Data> data = new ArrayList<Data>();
		
		for (int i = 0; i < countMax; i++) {
			data.add(new Data()
				.setX("" + (i + 1))
				.setY(Math.floor(Math.random() * (yRangeMax - yRangeMin + 1)) + yRangeMin));
		}
		
		series.setDataAsArrayObject(data);
		
		return series;
	}
	
}