package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.plotoptions.bar.colors.Ranges;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ColumnWithNegativeValues extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BAR);

		chartOptions.getPlotOptions().getBar().setColumnWidth("80%").getColors().getRanges().add(
				new Ranges().setFrom(-100).setTo(-46).setColor(new Color("#F15B46")));
		chartOptions.getPlotOptions().getBar().getColors().getRanges().add(
				new Ranges().setFrom(-45).setTo(0).setColor(new Color("#FEB019")));
		
		chartOptions.getDataLabels().setEnabled(false);
		
		chartOptions.getYaxisSingle().getTitle().setText("Growth");
		chartOptions.getYaxisSingle().getLabels().setFormatter(
				new Function("return y.toFixed(0) + \"%\";", "y"));
		
		chartOptions.getXaxis().setType(AxisType.DATETIME)
			.setCategoriesAsArrayString(Arrays.asList(
					"2011-01-01", "2011-02-01", "2011-03-01", "2011-04-01", "2011-05-01", "2011-06-01",
					"2011-07-01", "2011-08-01", "2011-09-01", "2011-10-01", "2011-11-01", "2011-12-01",
					"2012-01-01", "2012-02-01", "2012-03-01", "2012-04-01", "2012-05-01", "2012-06-01",
					"2012-07-01", "2012-08-01", "2012-09-01", "2012-10-01", "2012-11-01", "2012-12-01",
					"2013-01-01", "2013-02-01", "2013-03-01", "2013-04-01", "2013-05-01", "2013-06-01",
					"2013-07-01", "2013-08-01", "2013-09-01"))
			.getLabels().setRotate(-90);
		
		Series series = new Series();
		series.setName("Cash Flow");
		series.setDataAsArrayNumber(Arrays.asList(
			  1.45, 5.42, 5.9, -0.42, -12.6, -18.1, -18.2, -14.16, -11.1, -6.09, 0.34, 3.88, 13.07,
		      5.8, 2, 7.37, 8.1, 13.57, 15.75, 17.1, 19.8, -27.03, -54.4, -47.2, -43.3, -18.6, -48.6, 
		      -41.1, -39.6, -37.6, -29.4, -21.4, -2.4));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}