package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;
import java.util.Date;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class CustomColorsTimeLine extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.RANGEBAR);
		
		chartOptions.getPlotOptions().getBar()
			.setHorizontal(true).setDistributed(true).getDataLabels().setHideOverflowingLabels(false);
		
		chartOptions.getDataLabels().setEnabled(true).setFormatter(getFormatter())
			.getStyle().setColorsAsArrayColor(Arrays.asList(new Color("#f3f4f5"), new Color("#fff")));
		
		chartOptions.getXaxis().setType(AxisType.DATETIME);
		chartOptions.getYaxisSingle().setShow(false);

		chartOptions.getGrid().getRow().setOpacity(1)
			.setColors(Arrays.asList(new Color("#f3f4f5"), new Color("#fff")));

		chartOptions.getSeries().add(getData());

		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private Series getData() {
		Series series = new Series();;
		
		series.setDataAsArrayObject(Arrays.asList(
			new Data().setX("Analysis") 
					  .setY(Arrays.asList(new Date("2019/02/28").getTime(), new Date("2019/03/05").getTime())),
			new Data().setX("Design")
					  .setY(Arrays.asList(new Date("2019/03/05").getTime(), new Date("2019/03/09").getTime())),
			new Data().setX("Coding")
					  .setY(Arrays.asList(new Date("2019/03/08").getTime(), new Date("2019/03/11").getTime())),
			new Data().setX("Testing")
					  .setY(Arrays.asList(new Date("2019/03/09").getTime(), new Date("2019/03/13").getTime())),
			new Data().setX("Deployment")
					  .setY(Arrays.asList(new Date("2019/03/13").getTime(), new Date("2019/03/18").getTime()))
				));
		
		return series;
	}
	
	/**
	 * 
	 * @return
	 */
	private Function getFormatter() {
		Function f = new Function();
		f.addParameter("val");
		f.addParameter("opts");
		
		f.setFunctionBody("var label = opts.w.globals.labels[opts.dataPointIndex]; " + 
							"var a = moment(val[0]); " + 
							"var b = moment(val[1]); " + 
							"var diff = b.diff(a, 'days'); " + 
							"return label + ': ' + diff + (diff > 1 ? ' days' : ' day');");
		
		return f;
	}
	
}