package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.DataLabelsPosition;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.TextAnchor;
import com.hyjavaapex.model.apexcharts.constants.Theme;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class CustomDataLabelsBar extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BAR);
		chartOptions.getPlotOptions().getBar().setBarHeight("100%").setDistributed(true).setHorizontal(true)
			.getDataLabels().setPosition(DataLabelsPosition.BOTTOM);
		
		chartOptions.setColors(Arrays.asList(
				new Color("#33b2df"), new Color("#546E7A"), new Color("#d4526e"), new Color("#13d8aa"),
				new Color("#A5978B"), new Color("#2b908f"), new Color("#f9a3a4"), new Color("#90ee7e"), 
				new Color("#f48024"), new Color("#69d2e7")));

		chartOptions.getDataLabels().setEnabled(true).setTextAnchor(TextAnchor.START)
			.setFormatter(new Function("return opt.w.globals.labels[opt.dataPointIndex] + \":  \" + val;", "val", "opt"))
			.setOffsetX(0)
			.getStyle().setColorsAsArrayColor(Arrays.asList(new Color("#fff")));
		chartOptions.getDataLabels().getDropShadow().setEnabled(true);
		
		chartOptions.getStroke().setWidth(1).setColors(Arrays.asList(new Color("#fff")));

		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList(
				"South Korea", "Canada", "United Kingdom", "Netherlands", "Italy", 
				"France", "Japan", "United States", "China", "India"));
		chartOptions.getYaxisSingle().getLabels().setShow(false);
		
		chartOptions.getTitle().setText("Custom DataLabels").setAlign(HorizontalAlign.CENTER).setFloating(true);
		chartOptions.getSubtitle().setText("Category Names as DataLabels inside bars").setAlign(HorizontalAlign.CENTER);
		
		chartOptions.getTooltip().setTheme(Theme.DARK).getX().setShow(false);
		chartOptions.getTooltip().getY().getTitle().setFormatter(new Function("return ''"));
		
		Series series = new Series();
		series.setDataAsArrayNumber(Arrays.asList(400, 430, 448, 470, 540, 580, 690, 1100, 1200, 1380));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}