package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class DistributedColumns extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BAR);
		chartOptions.setColors(Arrays.asList(
				new Color("#008FFB"), new Color("#00E396"), new Color("#FEB019"), new Color("#FF4560"),
				new Color("#775DD0"), new Color("#546E7A"), new Color("#26a69a"), new Color("#D10CE8")));
		
		chartOptions.getPlotOptions().getBar().setColumnWidth("45%").setDistributed(true);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getLegend().setShow(false);
		
		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList( 
					"John Doe", "Joe Smith", "Jake Williams", "Amber", "Peter Brown",
		            "Mary Evans", "David Wilson", "Lily Roberts"))
			.getLabels().getStyle().setFontSize("12px").setColors(Arrays.asList(
				new Color("#008FFB"), new Color("#00E396"), new Color("#FEB019"), new Color("#FF4560"),
				new Color("#775DD0"), new Color("#546E7A"), new Color("#26a69a"), new Color("#D10CE8")));
		
		Series series = new Series();
		series.setDataAsArrayNumber(Arrays.asList(21, 22, 10, 28, 16, 21, 13, 30));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}