package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.DataLabelsPosition;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class GroupedBar extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BAR);
		
		chartOptions.getPlotOptions().getBar()
			.setHorizontal(true).getDataLabels().setPosition(DataLabelsPosition.TOP);
		
		chartOptions.getDataLabels().setEnabled(true).setOffsetX(-6)
			.getStyle().setFontSize("12px").getColorsAsArrayColor().add(new Color("#fff"));
		
		chartOptions.getStroke().setShow(true).setWidth(1).getColors().add(new Color("#fff"));

		chartOptions.getXaxis()
			.setCategoriesAsArrayNumber(Arrays.asList(2001, 2002, 2003, 2004, 2005, 2006, 2007));
		
		Series series = new Series();
		series.setDataAsArrayNumber(Arrays.asList(44, 55, 41, 64, 22, 43, 21));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setDataAsArrayNumber(Arrays.asList(53, 32, 33, 52, 13, 44, 32));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}