package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.Yaxis;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.SeriesType;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class LineColumn extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.LINE);
		chartOptions.getStroke().setWidth(Arrays.asList(0, 4));
		
		chartOptions.getTitle().setText("Traffic Sources");
		chartOptions.getDataLabels().setEnabled(true).setEnabledOnSeries(Arrays.asList(1));
		chartOptions.setLabels(Arrays.asList(
				"01 Jan 2001", "02 Jan 2001", "03 Jan 2001", "04 Jan 2001", 
				"05 Jan 2001", "06 Jan 2001", "07 Jan 2001", "08 Jan 2001", 
				"09 Jan 2001", "10 Jan 2001", "11 Jan 2001", "12 Jan 2001"));

		chartOptions.getXaxis().setType(AxisType.DATETIME);
		
		Yaxis yaxis = new Yaxis();
		yaxis.getTitle().setText("Website Blog");		
		chartOptions.getYaxis().add(yaxis);
		
		yaxis = new Yaxis();
		yaxis.setOpposite(true).getTitle().setText("Social Media");		
		chartOptions.getYaxis().add(yaxis);
		
		Series series = new Series();
		series.setName("Website Blog").setType(SeriesType.COLUMN);
		series.setDataAsArrayNumber(Arrays.asList(440, 505, 414, 671, 227, 413, 201, 352, 752, 320, 257, 160));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Social Media").setType(SeriesType.LINE);
		series.setDataAsArrayNumber(Arrays.asList(23, 42, 35, 27, 43, 22, 17, 31, 22, 22, 12, 16));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}