package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.Yaxis;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.GradientType;
import com.hyjavaapex.model.apexcharts.constants.SeriesType;
import com.hyjavaapex.model.apexcharts.constants.Shade;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class LineColumnArea extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.LINE).setStacked(false);
		chartOptions.getStroke().setCurve(Curve.SMOOTH).setWidth(Arrays.asList(0, 2, 5));
		
		chartOptions.getPlotOptions().getBar().setColumnWidth("50%");
		chartOptions.getFill().setOpacity(Arrays.asList(0.85, 0.25, 1))
			.getGradient().setInverseColors(false).setShade(Shade.LIGHT)
				.setType(GradientType.VERTICAL).setOpacityFrom(0.85).setOpacityTo(0.55)
				.setStops(Arrays.asList(0, 100, 100, 100));
		
		chartOptions.setLabels(Arrays.asList(
			"01/01/2003", "02/01/2003", "03/01/2003", "04/01/2003", "05/01/2003", "06/01/2003", 
			"07/01/2003", "08/01/2003", "09/01/2003", "10/01/2003", "11/01/2003"));
		
		chartOptions.getMarkers().setSize(0);
		chartOptions.getXaxis().setType(AxisType.DATETIME);
		
		Yaxis yaxis = new Yaxis();
		yaxis.setMin(0).getTitle().setText("Points");		
		chartOptions.getYaxis().add(yaxis);
		
		chartOptions.getTooltip().setShared(true).setIntersect(false).getY().setFormatter(
			new Function("if(typeof y !== \"undefined\") { return  y.toFixed(0) + \" points\"; } return y;", "y"));
		
		Series series = new Series();
		series.setName("TEAM A").setType(SeriesType.COLUMN);
		series.setDataAsArrayNumber(Arrays.asList(23, 11, 22, 27, 13, 22, 37, 21, 44, 22, 30));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("TEAM B").setType(SeriesType.AREA);
		series.setDataAsArrayNumber(Arrays.asList(44, 55, 41, 67, 22, 43, 21, 41, 56, 27, 43));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("TEAM C").setType(SeriesType.LINE);
		series.setDataAsArrayNumber(Arrays.asList(30, 25, 36, 30, 45, 35, 64, 52, 59, 36, 39));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}