package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class MultiColorsFlippedHeatmap extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.HEATMAP);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getPlotOptions().getHeatmap().getColorScale().setInverse(true);
		
		chartOptions.setColors(Arrays.asList(
			new Color("#F3B415"), new Color("#F27036"), new Color("#663F59"), new Color("#6A6E94"), 
			new Color("#4E88B4"), new Color("#00A7C6"), new Color("#18D8D8"), new Color("#A9D794"), 
			new Color("#46AF78"), new Color("#A93F55"), new Color("#8C5E58"), new Color("#2176FF"), 
			new Color("#33A1FD"), new Color("#7A918D"), new Color("#BAFF29")));
		
		chartOptions.getTitle().setText("Color Scales flipped Vertically");
		
		chartOptions.getXaxis().setType(AxisType.CATEGORY).setCategoriesAsArrayString(Arrays.asList(
					"W1", "W2", "W3", "W4", "W5", "W6", "W7", "W8", 
					"W9", "W10", "W11", "W12", "W13", "W14", "W15"));
		
		String[] times = {"13:30", "13:00", "12:30", "12:00", "11:30", "11:00", "10:30", "10:00"};
		for (int i = 0; i < 8; i++) {
			chartOptions.getSeries().add(getData().setName(times[i]));
		}

		return apexchart;
	}

	/**
	 * 
	 * @return
	 */
	private Series getData() {
		int countMax = 15;
		int yRangeMin = 0;
		int yRangeMax = 90;
		
		Series series = new Series();
		List<Number> data = new ArrayList<Number>();
		
		for (int i = 0; i < countMax; i++) {
			data.add(Math.floor(Math.random() * (yRangeMax - yRangeMin + 1)) + yRangeMin);
		}
		
		series.setDataAsArrayNumber(data);
		
		return series;
	}
	
}