package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class MultiColorsHeatmap extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.HEATMAP);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.setColors(Arrays.asList(
			new Color("#F3B415"), new Color("#F27036"), new Color("#663F59"), new Color("#6A6E94"), 
			new Color("#4E88B4"), new Color("#00A7C6"), new Color("#18D8D8"), new Color("#A9D794"), 
			new Color("#46AF78"), new Color("#A93F55"), new Color("#8C5E58"), new Color("#2176FF"), 
			new Color("#33A1FD"), new Color("#7A918D"), new Color("#BAFF29")));
		chartOptions.getTitle().setText("HeatMap Chart (Different color shades for each series)");
		
		chartOptions.getXaxis().setType(AxisType.CATEGORY)
			.setCategoriesAsArrayString(Arrays.asList("10:00", "10:30", "11:00", "11:30", "12:00", 
													  "12:30", "01:00", "01:30"));

		chartOptions.getGrid().getPadding().setRight(20);
		
		for (int i = 0; i < 15; i++) {
			chartOptions.getSeries().add(getData().setName("W" + (i + 1)));
		}

		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private Series getData() {
		int countMax = 8;
		int yRangeMin = 0;
		int yRangeMax = 90;
		
		Series series = new Series();
		List<Data> data = new ArrayList<Data>();
		
		for (int i = 0; i < countMax; i++) {
			data.add(new Data()
				.setX("w" + (i + 1))
				.setY(Math.floor(Math.random() * (yRangeMax - yRangeMin + 1)) + yRangeMin));
		}
		
		series.setDataAsArrayObject(data);
		
		return series;
	}
	
}