package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class RadarMultipleSeries extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.RADAR)
			.getDropShadow().setEnabled(true).setBlur(1).setLeft(1).setTop(1);
		chartOptions.getTitle().setText("Radar Chart - Multi Series");
		
		chartOptions.getStroke().setWidth(2);
		chartOptions.getFill().setOpacity(0.1);
		chartOptions.getMarkers().setSize(0);

		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList("2011", "2012", "2013", "2014", "2015", "2016"));
		
		Series series = new Series();
		series.setName("Series 1");
		series.setDataAsArrayNumber(Arrays.asList(80, 50, 30, 40, 100, 20));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Series 2");
		series.setDataAsArrayNumber(Arrays.asList(20, 30, 40, 80, 20, 80));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Series 3");
		series.setDataAsArrayNumber(Arrays.asList(44, 76, 78, 13, 43, 10));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}