package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartAxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.common.Pair;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ScatterDateTime extends DemoChartBase {
	private static final long serialVersionUID = -260567073216228029L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.SCATTER)
			.getZoom().setType(ChartAxisType.XY);
		chartOptions.getDataLabels().setEnabled(false);

		chartOptions.getGrid().getXaxis().getLines().setShow(true);
		chartOptions.getGrid().getYaxis().getLines().setShow(true);
		
		chartOptions.getXaxis().setType(AxisType.DATETIME);
		chartOptions.getYaxisSingle().setMax(70);

		chartOptions.getSeries().add(new Series()
			.setName("TEAM 1").setDataAsArrayPairs(getData(20, 10, 60)));
		chartOptions.getSeries().add(new Series()
			.setName("TEAM 2").setDataAsArrayPairs(getData(20, 10, 60)));
		chartOptions.getSeries().add(new Series()
			.setName("TEAM 3").setDataAsArrayPairs(getData(30, 10, 60)));
		chartOptions.getSeries().add(new Series()
			.setName("TEAM 4").setDataAsArrayPairs(getData(10, 10, 60)));
		chartOptions.getSeries().add(new Series()
			.setName("TEAM 5").setDataAsArrayPairs(getData(30, 10, 60)));

		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private List<Pair> getData(int count, int min, int max) {
		Long x = 1486771200000L;
		List<Pair> data = new ArrayList<Pair>();
		
		for (int i = 0; i < count; i++) {
			data.add(new Pair(x, Math.floor(Math.random() * (max - min + 1)) + min));
			
			x += 86400000;
		}
		
		return data;
	}
	
}
