package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.Shade;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class SemiCircleGauge extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.RADIALBAR)
			.setOffsetY(-20).getSparkline().setEnabled(true);
		
		chartOptions.getPlotOptions().getRadialBar().setStartAngle(-90).setEndAngle(90)
			.getTrack().setBackground(new Color("#e7e7e7")).setStrokeWidth("97%").setMargin(5)
			.getDropShadow().setEnabled(true).setTop(2).setLeft(0).setColor(new Color("#999"))
			.setOpacity(1).setBlur(2);
		
		chartOptions.getPlotOptions().getRadialBar().getDataLabels()
			.getName().setShow(false);
		
		chartOptions.getPlotOptions().getRadialBar().getDataLabels()
			.getValue().setOffsetY(-2).setFontSize("22px");
		
		chartOptions.getGrid().getPadding().setTop(-10);
		
		chartOptions.getFill().setType(FillType.GRADIENT)
        	.getGradient().setShade(Shade.LIGHT)
        	.setShadeIntensity(0.4).setInverseColors(false).setOpacityFrom(1).setOpacityTo(1)
        	.setStops(Arrays.asList(0, 50, 53, 91));

		chartOptions.setLabels(Arrays.asList("Average Results"));
		chartOptions.setSeriesAsArrayNumber(Arrays.asList(76));
		
		return apexchart;
	}
	
}