package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class StackedArea extends DemoChartBase {
	private static final long serialVersionUID = 5742682049052371583L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.AREA).setStacked(true);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setCurve(Curve.SMOOTH);
		
		chartOptions.setColors(Arrays.asList(new Color("#008FFB"), new Color("#00E396"),new Color("#CED4DC")));
		chartOptions.getFill().setType(FillType.GRADIENT)
			.getGradient().setOpacityFrom(0.6).setOpacityTo(0.8);
		
		chartOptions.getXaxis().setType(AxisType.DATETIME);
		chartOptions.getLegend().setPosition(LegendPosition.TOP).setHorizontalAlign(HorizontalAlign.LEFT);
		
		Series series = new Series();
		series.setName("South");
		series.setDataAsArrayObject(getData(new Date("11 Feb 2017 GMT").getTime(), 10, 60, 20));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("North");
		series.setDataAsArrayObject(getData(new Date("11 Feb 2017 GMT").getTime(), 10, 20, 20));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Central");
		series.setDataAsArrayObject(getData(new Date("11 Feb 2017 GMT").getTime(), 10, 15, 20));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
	/**
	 * 
	 * @param time
	 * @param min
	 * @param max
	 * @param count
	 * @return
	 */
	private List<Data> getData(Long time, int min, int max, int count) {
		List<Data> data = new ArrayList<Data>();
		
		for (int i = 0; i < count; i++) {
			data.add(new Data().setX(time).setY(Math.floor(Math.random() * (max - min + 1)) + min));
			
			time += 86400000;
		}
		
		return data;
	}
	
}
