package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class StackedColumn extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.BAR).setStacked(true)
			.getToolbar().setShow(true);
		chartOptions.getChart().getZoom().setEnabled(true);
		
		chartOptions.getResponsiveSingle().setBreakpoint(480)
			.getOptions().getLegend().setPosition(LegendPosition.BOTTOM).setOffsetX(-10).setOffsetY(0);
		
		chartOptions.getPlotOptions().getBar().setHorizontal(false);

		chartOptions.getXaxis().setType(AxisType.DATETIME)
			.setCategoriesAsArrayString(Arrays.asList(
					"01/01/2011 GMT", "01/02/2011 GMT", "01/03/2011 GMT", "01/04/2011 GMT", 
					"01/05/2011 GMT", "01/06/2011 GMT"));

		chartOptions.getLegend().setPosition(LegendPosition.RIGHT).setOffsetY(40);
		chartOptions.getFill().setOpacity(1);
		
		Series series = new Series();
		series.setName("PRODUCT A");
		series.setDataAsArrayNumber(Arrays.asList(44, 55, 41, 67, 22, 43));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("PRODUCT B");
		series.setDataAsArrayNumber(Arrays.asList(13, 23, 20, 8, 13, 27));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("PRODUCT C");
		series.setDataAsArrayNumber(Arrays.asList(11, 17, 15, 15, 21, 14));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("PRODUCT D");
		series.setDataAsArrayNumber(Arrays.asList(21, 7, 25, 13, 22, 8));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}