package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.Shade;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class StrokedGauge extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight(450).setType(ChartType.RADIALBAR).setOffsetY(-10);
		chartOptions.getPlotOptions().getRadialBar()
			.setStartAngle(-135).setEndAngle(135)
			.getDataLabels().getName().setFontSize("16px").setColor(new Color("undefined")).setOffsetY(120);
		
		chartOptions.getPlotOptions().getRadialBar()
		.getDataLabels().getValue().setOffsetY(76).setFontSize("22px")
			.setColor(new Color("undefined")).setFormatter(new Function("return val + \"%\";", "val"));
		
		chartOptions.getFill().setType(FillType.GRADIENT).getGradient()
			.setShade(Shade.DARK).setShadeIntensity(0.15).setInverseColors(false)
			.setOpacityFrom(1).setOpacityTo(1).setStops(Arrays.asList(0, 50, 65, 91));
		
		chartOptions.getStroke().setDashArray(4);

		chartOptions.setLabels(Arrays.asList("Median Ratio"));
		chartOptions.setSeriesAsArrayNumber(Arrays.asList(67));
		
		return apexchart;
	}

}