package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.Theme;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.hyjavaapex.model.common.Pair;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class SynchronizedCharts extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;


	public Apexchart fbChartConfigure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.LINE).setId("fb").setGroup("social");
		
		chartOptions.setColors(Arrays.asList(new Color("#008FFB")));
		chartOptions.getYaxisSingle().getLabels().setMinWidth(40);
		commonConfigure(chartOptions);
		
		Series series = new Series();
		series.setDataAsArrayPairs(getData(10, 60));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
		
	/**
	 * 
	 * @return
	 */
	public Apexchart twChartConfigure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.LINE).setId("tw").setGroup("social");
		
		chartOptions.setColors(Arrays.asList(new Color("#546E7A")));
		chartOptions.getYaxisSingle().getLabels().setMinWidth(40);
		commonConfigure(chartOptions);
		
		Series series = new Series();
		series.setDataAsArrayPairs(getData(10, 30));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	public Apexchart ytChartConfigure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.AREA).setId("yt").setGroup("social");
		
		chartOptions.setColors(Arrays.asList(new Color("#00E396")));
		chartOptions.getYaxisSingle().getLabels().setMinWidth(40);
		commonConfigure(chartOptions);
		
		Series series = new Series();
		series.setDataAsArrayPairs(getData(10, 60));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
	/**
	 * 
	 * @param chartOptions
	 */
	private void commonConfigure(ChartOptions chartOptions) {
		chartOptions.getChart().setHeight(160).getToolbar().getTools().setSelection(false);
		
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setCurve(Curve.STRAIGHT);
		chartOptions.getMarkers().setSize(6).getHover().setSize(10);
		
		chartOptions.getTooltip().setFollowCursor(false).setTheme(Theme.DARK);
		chartOptions.getTooltip().getX().setShow(false);
		chartOptions.getTooltip().getMarker().setShow(false);
		chartOptions.getTooltip().getY().getTitle().setFormatter(new Function("return ''"));
		//chartOptions.getGrid().setClipMarkers(false); not in API
		
		chartOptions.getXaxis().setType(AxisType.DATETIME);
		chartOptions.getYaxisSingle().setTickAmount(2);
	}

	/**
	 * 
	 * @return
	 */
	private List<Pair> getData(int min, int max) {
		Long x = 1486771200000L;
		List<Pair> data = new ArrayList<Pair>();
		
		for (int i = 0; i < 20; i++) {
			data.add(new Pair(x, Math.floor(Math.random() * (max - min + 1)) + min));
			
			x += 86400000;
		}
		
		return data;
	}
	
	/**
	 * 
	 */
	public List<Apexchart> getCharts() {
		List<Apexchart> chartList = new ArrayList<Apexchart>();
		
		chartList.add(fbChartConfigure());
		chartList.add(twChartConfigure());
		chartList.add(ytChartConfigure());
		
		return chartList;
	}
	
}