package com.webonlineapp.hyjavachartsdemo9.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.addon.regression.SeriesScatterR;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.Layout;
import com.hyjavacharts.model.highcharts.constants.VerticalAlign;
import com.hyjavacharts.model.highcharts.constants.ZoomType;
import com.hyjavacharts.model.highcharts.series.seriesscatter.Data;
import com.webonlineapp.hyjavachartsdemo9.charts.DemoChartBase;

public class BasicRegression extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
	    
		chartOptions.getChart().setType(ChartType.SCATTER).setZoomType(ZoomType.XY);
		
		chartOptions.getTitle().setText("Basic default settings: linear regression with equation in the legend");
		chartOptions.getSubtitle().setText("Source: Heinz  2003");
	
		XAxis xAxi = new XAxis();
		xAxi.setStartOnTick(true).setEndOnTick(true).setShowLastLabel(true)
			.getTitle().setText("Height (cm)");
		chartOptions.getXAxis().add(xAxi);
	
		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("Weight (kg)");
		chartOptions.getYAxis().add(yAxi);
		
		chartOptions.getLegend()
			.setLayout(Layout.VERTICAL).setAlign(HorizontalAlign.LEFT)
			.setVerticalAlign(VerticalAlign.TOP).setX(100).setY(70)
			.setFloating(true).setBackgroundColor(new Color("#FFFFFF")).setBorderWidth(1);
		
		chartOptions.getPlotOptions().getScatter()
			.getMarker().setRadius(5)
			.getStates().getHover().setEnabled(true).setLineColor(new Color(100,100,100));
		chartOptions.getPlotOptions().getScatter()
			.getStates().getHover().setEnabled(false);
		chartOptions.getPlotOptions().getScatter()
			.getTooltip().setHeaderFormat("<b>{series.name}</b><br>").setPointFormat("{point.x} cm, {point.y} kg");
		
		chartOptions.getCaption().setText("<b>HyJavaCharts Add-Ons: </b>Highcharts Regression"
				+ "<br>Linear and non-linear regression support for highcharts. Allows you to add regression series to any existing series on your chart."
				+ "<br>See https://github.com/streamlinesocial/highcharts-regression");
	
		SeriesScatterR seriesLine = new SeriesScatterR();
		seriesLine.setRegression(true).setName("Test input").setColor(new Color(223, 83, 83, .5));
		seriesLine.setDataAsArrayObject(Arrays.asList(
				new Data().setX(1).setY(1), 
				new Data().setX(2).setY(3),
				new Data().setX(3).setY(9)));
		chartOptions.getSeries().add(seriesLine);
		
		return highChart;
	}
	
}
