package com.webonlineapp.hyjavachartsdemo9.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.AxisType;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.series.SeriesLollipop;
import com.hyjavacharts.model.highcharts.series.serieslollipop.Data;
import com.webonlineapp.hyjavachartsdemo9.charts.DemoChartBase;

public class LollipopSeries extends DemoChartBase {
	private static final long serialVersionUID = 3193798714079102492L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.LOLLIPOP);
		chartOptions.getTitle().setText("Top 10 Countries by Population");
		chartOptions.getSubtitle().setText("2018");
		
		chartOptions.getLegend().setEnabled(false);
		chartOptions.getTooltip().setShared(true);

		XAxis xAxis = new XAxis();
		xAxis.setType(AxisType.CATEGORY);
		chartOptions.getXAxis().add(xAxis);

		YAxis yAxis = new YAxis();
		yAxis.getTitle().setText("Population");
		chartOptions.getYAxis().add(yAxis);

		SeriesLollipop seriesLollipop = new SeriesLollipop();
		seriesLollipop.setName("Population");
		seriesLollipop.setDataAsArrayObject(Arrays.asList(
				new Data().setName("China").setLow(1427647786),
				new Data().setName("India").setLow(1352642280),
				new Data().setName("United States").setLow(327096265),
				new Data().setName("Indonesia").setLow(267670543),
				new Data().setName("Pakistan").setLow(212228286),
				new Data().setName("Brazil").setLow(209469323),
				new Data().setName("Nigeria").setLow(195874683),
				new Data().setName("Bangladesh").setLow(161376708),
				new Data().setName("Russia").setLow(145734038),
				new Data().setName("Mexico").setLow(126190788)
				));
		chartOptions.getSeries().add(seriesLollipop);
		
		return highChart;
	}
	
}
