package com.webonlineapp.hyjavachartsdemo9.examplecharts;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.AxisType;
import com.hyjavacharts.model.highcharts.constants.Cursor;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.VerticalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.webonlineapp.hyjavachartsdemo9.chartdata.LinePointsData;
import com.webonlineapp.hyjavachartsdemo9.charts.DemoChartBase;

public class LinePoints extends DemoChartBase {
	private static final long serialVersionUID = -3633954510824049807L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
	    
		chartOptions.getTitle().setText("Daily sessions at www.highcharts.com");
		chartOptions.getSubtitle().setText("Source: Google Analytics");
		
		XAxis xAxi = new XAxis();
		xAxi.setType(AxisType.DATETIME)
			.setTickInterval(7 * 24 * 3600 * 1000)
			.setTickWidth(0)
			.setGridLineWidth(1)
			.getLabels().setAlign(HorizontalAlign.LEFT).setX(3).setY(-3);
		chartOptions.getXAxis().add(xAxi);
		
		YAxis yAxi = new YAxis().setShowFirstLabel(false);
		yAxi.getTitle().setText(null);
		yAxi.getLabels().setAlign(HorizontalAlign.LEFT).setX(3).setY(16).setFormat("{value:.,0f}");
		chartOptions.getYAxis().add(yAxi);
		
		yAxi = new YAxis().setLinkedTo(0).setGridLineWidth(0).setOpposite(true).setShowFirstLabel(false);
		yAxi.getTitle().setText(null);
		yAxi.getLabels().setAlign(HorizontalAlign.RIGHT).setX(-3).setY(16).setFormat("{value:.,0f}");
		chartOptions.getYAxis().add(yAxi);
		
		chartOptions.getLegend().setAlign(HorizontalAlign.LEFT).setVerticalAlign(VerticalAlign.TOP).setBorderWidth(0);
		
		chartOptions.getTooltip().setShared(true).setCrosshairs(true);

		chartOptions.getPlotOptions().getSeries().setCursor(Cursor.POINTER).getMarker().setLineWidth(1);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("All sessions").setLineWidth(4).getMarker().setRadius(4);
		chartOptions.getSeries().add(seriesLine);
		
		seriesLine = new SeriesLine();
		seriesLine.setName("New users");
		chartOptions.getSeries().add(seriesLine);
		
		chartOptions.getData()
			.setCsv(new LinePointsData().getCSV())
//			.setCsvURL("https://www.hyjavacharts.com/content/chart-data/analytics.csv")
			.getBeforeParse().setFunctionBody("return csv.replace(/\\n\\n/g, '\\n');").addParameter("csv");
		
		return highChart;
	}

}
