package com.webonlineapp;

import com.vaadin.ui.AbstractJavaScriptComponent;
import com.vaadin.ui.AbstractOrderedLayout;
import com.vaadin.ui.JavaScript;

@com.vaadin.annotations.JavaScript({
	"jquery-3.2.1.min.js", 
	"https://code.highcharts.com/stock/9.3.3/highstock.js",
	"https://code.highcharts.com/9.3.3/modules/exporting.js",
	"https://cdn.jsdelivr.net/npm/apexcharts@3.33.2",
	"charts-connector.js"})

public class ChartComponent extends AbstractJavaScriptComponent {
    private static final long serialVersionUID = 7738496276049495017L;
    public static int currChartId = 0;
    protected int chartId = nextChartId();
    private String json;

    /**
     * Creates the chart object.
     */
    public ChartComponent() {
        setId(getDomId());
        getState().domId = getDomId();
        getState().hcjs = "";
        getState().chartType = "highcharts";
    }

    /**
     * 
     * @return
     */
    public static int nextChartId() {
        return ++currChartId;
    }

    /**
     * 
     */
    public void reRender() {
        int componentIndex;

        AbstractOrderedLayout container = (AbstractOrderedLayout) this.getParent();
        componentIndex = container.getComponentIndex(this);
        container.getComponentIndex(this);
        container.removeComponent(this);
        container.addComponent(ChartFactory.renderChart(json), componentIndex);
    }

    /**
     * 
     */
    @Override
    protected ChartState getState() {
        return (ChartState) super.getState();
    }

    /**
     * 
     * @return
     */
    public String getDomId() {
        return "thechart_" + chartId;
    }

    /**
     * 
     * @param json
     */
    public void setChartoptions(String json) {
    	this.json = json;
        getState().hcjs = "var options = " + json;
    }
    
    public void setChartType(String chartType) {
        getState().chartType = chartType;
    }

    /**
     * 
     * @param json
     */
    public void redraw(String json) {
        this.setChartoptions(json);
        JavaScript.getCurrent().execute("$(\"#" + this.getDomId() + "\").redraw();");
    }
    
    /**
     * 
     * @param js
     */
	public void manipulateChart(String js) {
		JavaScript.eval("var chart = $('#" + getDomId() + "').highcharts();\n" + js);
	}
	
	/**
	 * 
	 * @param js
	 */
	public void setOptions(String js) {
		String Highcharts_setOptions = "Highcharts.setOptions(" + js + ");";
		
		JavaScript.eval(Highcharts_setOptions);
	}
}