package com.webonlineapp;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavacharts.chart.Highchart;
import com.hyjavastock.chart.Highstock;

public class ChartPage extends WebPage {
	private static final long serialVersionUID = 1L;
	
	/**
	 * Build the selected chart
	 * @param parameters
	 */
	public ChartPage(final PageParameters parameters) {
		super(parameters);
		String selectedChart = parameters.get("param1").toString();
		
		if (selectedChart.equals("Highstock Column")) {
			Highstock hs = new HighstockColumn().configure();
			String chartOptionsScript = "Highcharts.stockChart('container', " + hs.chartOptionsToJs() + ");";
    		
    		add(new Label("script", chartOptionsScript).setEscapeModelStrings(false));
		}
		else if (selectedChart.equals("ApexCharts Column")) {
			Apexchart apexchart = new ApexChartsBasicColumn().configure();
   		
			String chartOptionsScript = 
    			"var chart = new ApexCharts(document.querySelector('#container'), " + apexchart.chartOptionsToJs() + ");" + 
    			"chart.render();";
			
    		add(new Label("script", chartOptionsScript).setEscapeModelStrings(false));
		}
		else {
	        Highchart hc = null;
	        if (selectedChart.equals("Highcharts Line")) {
	        	hc = new HighchartsLine().configure();
	    		String chartOptionsScript = "Highcharts.chart('container', " + hc.chartOptionsToJs() + ");";
	    		
	    		add(new Label("script", chartOptionsScript).setEscapeModelStrings(false));
	        }
	        else {
	        	hc = new HighchartsPie().configure();
	      		String chartOptionsScript = "Highcharts.chart('container', " + hc.chartOptionsToJs() + ");";
	    		
	    		add(new Label("script", chartOptionsScript).setEscapeModelStrings(false));
	        }
		}
	}

}
