package com.webonlineapp.hyjavastockdemo9.charts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.webonlineapp.hyjavastockdemo9.examplecharts.*;

public class DemoCharts {
	// Web application charts
	private static final List<DemoChart> demoChartsList = new ArrayList<DemoChart>(Arrays.asList(
		// General
		new DemoChart("General"),
		//new DemoChart("Stock Chart With GUI", new StockChartWithGUI(), false),
		new DemoChart("Stock Chart With GUI", new StockChartWithGUI()),
    	new DemoChart("Single Line Series", new SingleLineSeries()),
    	new DemoChart("Two Panes, Candlestick", new TwoPanesCandlestick()),
    	new DemoChart("Compare Multiple Series", new CompareMultipleSeries()),
    	new DemoChart("Intraday Area", new IntraDayArea()),
    	new DemoChart("Intraday With Breaks", new IntraDayWithBreaks()),
    	new DemoChart("Intraday Candlestick", new IntraDayCandleStick()),
    	new DemoChart("Flags Marking Events", new FlagsMarkingEvents()),
    	new DemoChart("Cumulative Sum ** NEW **", new CumulativeSum()),
    	new DemoChart("Points With Data Grouping", new PointsWithDataGrouping()),
    	new DemoChart("Dynamically Updated Data", new DynamicallyUpdatedData()),
    	
    	// Chart Types
    	new DemoChart("Chart Types"),
    	new DemoChart("Heiken Ashi ** NEW **", new HeikenAshi()),
    	new DemoChart("HLC ** NEW **", new HLC()),
    	new DemoChart("Hollow Candlestick ** NEW **", new HollowCandlestick()),
    	new DemoChart("Line With Markers And Shadow", new LineWithMarkersAndShadow()),
    	new DemoChart("Spline", new Spline()),
    	new DemoChart("Step Line", new StepLine()),
    	new DemoChart("Area", new Area()),
    	new DemoChart("Area Spline", new AreaSpline()),
    	new DemoChart("Area Range", new AreaRange()),
    	new DemoChart("Depth Chart", new DepthChart()),
    	new DemoChart("Area Spline Range", new AreaSplineRange()),
    	new DemoChart("Candlestick", new Candlestick()),
    	new DemoChart("OHLC", new OHLC()),
    	new DemoChart("Column", new Column()),
    	new DemoChart("Column Range", new ColumnRange()),
    	new DemoChart("Point Markers Only", new PointMarkersOnly()),
    	
    	// Various Features
    	new DemoChart("Various Features"),
    	new DemoChart("Plot Lines On Y Axis", new PlotLinesOnYAxis()),
    	new DemoChart("Plot Bands On Y Axis", new PlotBandsOnYAxis()),
    	new DemoChart("Reversed Y Axis", new ReversedYAxis()),
    	new DemoChart("Styled Scroll Bar", new StyledScrollBar()),
    	new DemoChart("Disabled Scroll Bar", new DisabledScrollBar()),
    	new DemoChart("Disabled Navigator", new DisabledNavigator()),
    	
    	// Flags and Indicators
    	new DemoChart("Flags and Indicators"),
    	new DemoChart("MACD Pivot Points", new MACDPivotPoints()),
    	new DemoChart("SMA Volume By Price", new SMAVolumeByPrice()),
    	new DemoChart("Flags Placement", new FlagsPlacement()),
    	new DemoChart("Flags Shapes And Colors", new FlagsShapesAndColors())
		));
	
	// Export server charts
	private static final List<DemoChart> demoChartsExportServerList = new ArrayList<DemoChart>(Arrays.asList(
		));

	/**
	 * 
	 * @param exportServer
	 * @return
	 */
	public static final List<DemoChart> getDemoChartsList(boolean exportServer) {
		return exportServer ? demoChartsList : demoChartsList;
	}


}
