package com.webonlineapp.hyjavastockdemo9.components;

import com.vaadin.flow.component.Component;
import com.vaadin.flow.component.HasComponents;
import com.vaadin.flow.component.HasSize;
import com.vaadin.flow.component.Tag;
import com.vaadin.flow.component.UI;
import com.vaadin.flow.component.page.Page;
import com.webonlineapp.hyjavastockdemo9.util.ServletUtil;

@Tag("div")
public class HighstockComponent extends Component implements HasComponents, HasSize {
	private static final long serialVersionUID = 806054527112127036L;
	
	private static long chartId = 1;
	private boolean highcharts = false;
	
	
	/**
	 * 
	 */
	public HighstockComponent() { 
		UI.getCurrent().getPage().addJavaScript(ServletUtil.getContextPath() + "/js/hs-demo.js");
		
		UI.getCurrent().getPage().addStyleSheet(ServletUtil.getContextPath() + "/css/gui.css");
		UI.getCurrent().getPage().addStyleSheet(ServletUtil.getContextPath() + "/css/popup.css");

        setId("highstock_" + getNextChartId());
        getElement().setAttribute("class", "chart");
 	}
	
	/**
	 * 
	 * @param chartOptions
	 */
	public void displayChart(String chartOptions) {
		displayChart("", chartOptions);
	}
	
	/**
	 * 
	 * @param globalOptions
	 * @param chartOptions
	 */
	public void displayChart(String globalOptions, String chartOptions) {
		Page page = UI.getCurrent().getPage();
		
		if (globalOptions != null && !globalOptions.equals("")) {
			String globalOptionsJs = "Highcharts.setOptions(" + globalOptions + ");";
			page.executeJs(globalOptionsJs);
		}

    	String chartOptionsJs = (highcharts ? "Highcharts.chart('" : "Highcharts.stockChart('") + getId().get() + "', " + chartOptions + ");";
    	page.executeJs(chartOptionsJs);
	}
	
	/**
	 * 
	 * @return
	 */
	private long getNextChartId() {
		chartId++;
		
		if (chartId > 10000) {
			chartId = 1;
		}
		
		return chartId;
	}

	/**
	 * 
	 * @param highcharts
	 */
	public void setHighcharts(boolean highcharts) {
		this.highcharts = highcharts;
	}

}
