package com.webonlineapp.hyjavastockdemo9.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Unit;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesCandlestick;
import com.webonlineapp.hyjavastockdemo9.chartdata.AAPLOpenHighLowCloseData;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;

public class Candlestick extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(1);
		
		SeriesCandlestick seriesCandlestick = new SeriesCandlestick();
		seriesCandlestick.setType(SeriesType.CANDLESTICK).setName("AAPL Stock Price");
		
		seriesCandlestick.getDataGrouping().getUnits().add(new Unit("week", new ArrayList<Number>(Arrays.asList(1))));
		seriesCandlestick.getDataGrouping().getUnits().add(new Unit("month", new ArrayList<Number>(Arrays.asList(1, 2, 3, 4, 6))));
		
		seriesCandlestick.getDataAsJsValue().setJsValue(new AAPLOpenHighLowCloseData().get());
		chartOptions.getSeries().add(seriesCandlestick);
		
		return highStock;
	}
	
}