package com.webonlineapp.hyjavastockdemo9.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.PointIntervalUnit;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;

public class CumulativeSum extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("Cumulative Sum");
		chartOptions.getSubtitle().setText("Displays the sum of all the previous values and the current value (only within visible range)");
		
		chartOptions.getPlotOptions().getSeries()
			.setCumulative(true)
			.setPointStart(1609459200000L)	//Date.UTC(2021, 0, 1)
			.setPointIntervalUnit(PointIntervalUnit.DAY);
		
		chartOptions.getRangeSelector().setEnabled(false);
		chartOptions.getTooltip()
			.setPointFormat("<span style=\"color:{series.color}\">{series.name}</span>: <b>{point.y}</b> ({point.cumulativeSum})<br/>")
			.setChangeDecimals(2)
			.setValueDecimals(2);
		
		chartOptions.getXAxisSingle().setMinRange(3 * 24 * 36e5).setMax(1609891200000L); 	// Date.UTC(2021, 0, 6)

		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setDataAsArrayNumber(new ArrayList<Number>(Arrays.asList(1, 2, 5, 10, 20, 50, 100, -100, 100, -100)));
		chartOptions.getSeries().add(seriesLine);
		
		seriesLine = new SeriesLine();
		seriesLine.setDataAsArrayNumber(new ArrayList<Number>(Arrays.asList(100, -50, -15, 15, -50, -20, -30, 100, -100, 100)));
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}
	
}