package com.webonlineapp.hyjavastockdemo9.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.GenericOption;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesHlc;
import com.webonlineapp.hyjavastockdemo9.chartdata.AAPLOpenHighLowCloseData;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;

public class HLC extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
		
		chartOptions.getRangeSelector().setSelected(2);
		chartOptions.getTitle().setText("AAPL Stock Price");

		SeriesHlc seriesHlc = new SeriesHlc();
		seriesHlc.setType(SeriesType.HLC).setName("AAPL Stock Price")
			.getDataAsJsValue().setJsValue(new AAPLOpenHighLowCloseData().get());
		seriesHlc.get_genericOption().add(new GenericOption("useOhlcData", "true"));	// useOhlcData is missing from api
		chartOptions.getSeries().add(seriesHlc);
		
		return highStock;
	}
	
}