package com.webonlineapp.hyjavastockdemo9.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesCandlestick;
import com.hyjavastock.model.highstock.series.SeriesHeikinashi;
import com.webonlineapp.hyjavastockdemo9.chartdata.AAPLOpenHighLowCloseData;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;

public class HeikenAshi extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("Candlestick and Heiken Ashi series comparison.");
		chartOptions.getRangeSelector().setSelected(1);
		
		YAxis yAxis = new YAxis();
		yAxis.setHeight("50%").getTitle().setText("Candlestick");
		chartOptions.getYAxis().add(yAxis);
		
		yAxis = new YAxis();
		yAxis.setTop("50%").setHeight("50%").setOffset(0).getTitle().setText("Heikin Ashi");
		chartOptions.getYAxis().add(yAxis);
		
		SeriesCandlestick seriesCandlestick = new SeriesCandlestick();
		seriesCandlestick.setType(SeriesType.CANDLESTICK).setName("Candlestick");
		seriesCandlestick.getDataAsJsValue().setJsValue(new AAPLOpenHighLowCloseData().get());
		chartOptions.getSeries().add(seriesCandlestick);
		
		SeriesHeikinashi seriesHeikinashi = new SeriesHeikinashi();
		seriesHeikinashi.setType(SeriesType.HEIKINASHI).setName("Heikin Ashi").setYAxis(1);
		seriesHeikinashi.getDataAsJsValue().setJsValue(new AAPLOpenHighLowCloseData().get());
		chartOptions.getSeries().add(seriesHeikinashi);
		
		return highStock;
	}
	
}