package com.webonlineapp.hyjavastockdemo9.examplecharts;

import javax.ws.rs.client.WebTarget;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.RangeSelectorButtonType;
import com.hyjavastock.model.highstock.constants.ZoomType;
import com.hyjavastock.model.highstock.rangeselector.Buttons;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;
import com.webonlineapp.hyjavastockdemo9.services.RestService;

public class PointsWithDataGrouping extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
		chartOptions.getChart().setZoomType(ZoomType.X);

		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.DAY).setCount(3).setText("3d"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.WEEK).setCount(1).setText("1w"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.MONTH).setCount(1).setText("1m"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.MONTH).setCount(6).setText("6m"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.YEAR).setCount(1).setText("1y"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.ALL).setText("ALL"));
		chartOptions.getRangeSelector().setSelected(3);
		
		chartOptions.getTitle().setText("Hourly temperatures in Vik i Sogn, Norway, 2009-2017");
		
		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("Temperature (°C)");
		chartOptions.getYAxis().add(yAxi);
				
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("Temperature")
			.getTooltip().setValueDecimals(1).setValueSuffix("°C");
		seriesLine.setPointStart(new Long("1230764400000"));
		seriesLine.setPointInterval(3600000);
		seriesLine.getDataAsJsValue().setJsValue(getSeriesData());
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}
	
	/**
	 * 
	 * @return
	 */
	private String getSeriesData() {
		// Some of our example charts use a REST service to retrieve data.
		// REST service returns json data
		WebTarget webTarget = new RestService().getWebTarget();
		
		return webTarget.path("HighstockLargeDatasetJson").request().get(String.class);
	}
	
}