package com.webonlineapp.hyjavastockdemo9.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Function;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.YAxis;
import com.hyjavastock.model.highstock.constants.HorizontalAlign;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.constants.ToolTipShape;
import com.hyjavastock.model.highstock.series.SeriesColumn;
import com.hyjavastock.model.highstock.series.SeriesOhlc;
import com.webonlineapp.hyjavastockdemo9.chartdata.AAPLOpenHighLowCloseData;
import com.webonlineapp.hyjavastockdemo9.chartdata.AAPLVolumeData;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;

public class StockChartWithGUI extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getExporting().setEnabled(false);
		
		YAxis yAxi = new YAxis();
		yAxi.setHeight("80%").getLabels().setAlign(HorizontalAlign.LEFT);
		yAxi.getResize().setEnabled(true);
		chartOptions.getYAxis().add(yAxi);
		
		yAxi = new YAxis();
		yAxi.setTop("80%").setHeight("20%").setOffset(0).getLabels().setAlign(HorizontalAlign.LEFT);
		chartOptions.getYAxis().add(yAxi);
		
		String positionerJs = "var chart = this.chart, position; if (point.isHeader) { position = { x: Math.max( chart.plotLeft, Math.min( point.plotX + chart.plotLeft - width / 2,  chart.chartWidth - width - chart.marginRight) ), y: point.plotY }; } else { position = { x: point.series.chart.plotLeft, y: point.series.yAxis.top - chart.plotTop }; } return position;";
		Function positioner = new Function(positionerJs);
		positioner.addParameter("width");
		positioner.addParameter("height");
		positioner.addParameter("point");
		
		chartOptions.getTooltip()
			.setShape(ToolTipShape.SQUARE)
			.setHeaderShape(ToolTipShape.CALLOUT)
			.setBorderWidth(0)
			.setShadow(false)
			.setPositioner(positioner);
				
		SeriesOhlc seriesOhlc = new SeriesOhlc();
		seriesOhlc.setType(SeriesType.OHLC).setId("aapl-ohlc").setName("AAPL Stock Price");
		seriesOhlc.getDataAsJsValue().setJsValue(new AAPLOpenHighLowCloseData().get());
		chartOptions.getSeries().add(seriesOhlc);
		
		SeriesColumn seriesColumn = new SeriesColumn();
		seriesColumn.setType(SeriesType.COLUMN).setId("aapl-volume").setName("AAPL Volume").setYAxis(1);
		seriesColumn.getDataAsJsValue().setJsValue(new AAPLVolumeData().get());
		chartOptions.getSeries().add(seriesColumn);
		
		return highStock;
	}
	
}