package com.webonlineapp.hyjavastockdemo9.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Unit;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesColumn;
import com.webonlineapp.hyjavastockdemo9.chartdata.AAPLVolumeData;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;

public class Column extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
		
		chartOptions.getChart().setAlignTicks(false);
		chartOptions.getRangeSelector().setSelected(1);
	    
		chartOptions.getTitle().setText("AAPL Stock Volume");
		
		SeriesColumn seriesColumn = new SeriesColumn();
		seriesColumn.setType(SeriesType.COLUMN).setName("AAPL");

		seriesColumn.getDataGrouping().getUnits().add(new Unit("week", new ArrayList<Number>(Arrays.asList(1))));
		seriesColumn.getDataGrouping().getUnits().add(new Unit("month", new ArrayList<Number>(Arrays.asList(1, 2, 3, 4, 6))));
		
		seriesColumn.getDataAsJsValue().setJsValue(new AAPLVolumeData().get());
		chartOptions.getSeries().add(seriesColumn);
		
		return highStock;
	}
	
}