package com.webonlineapp.hyjavastockdemo9.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo9.chartdata.AAPLCloseData;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;

public class DisabledScrollBar extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(1);

		chartOptions.getScrollbar().setEnabled(false);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("AAPL");
		seriesLine.getTooltip().setValueDecimals(2);
		seriesLine.getDataAsJsValue().setJsValue(new AAPLCloseData().get());
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}
	
}