package com.webonlineapp.hyjavastockdemo9.examplecharts;

import java.util.ArrayList;

import javax.ws.rs.client.WebTarget;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.common.LinearGradient;
import com.hyjavastock.model.common.NullOption;
import com.hyjavastock.model.common.Stop;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.RangeSelectorButtonType;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.rangeselector.Buttons;
import com.hyjavastock.model.highstock.series.SeriesArea;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;
import com.webonlineapp.hyjavastockdemo9.services.RestService;

public class IntraDayArea extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL stock price by minute");
		chartOptions.getSubtitle().setText("Using ordinal X axis");
		
		chartOptions.getXAxisSingle().setGridLineWidth(0);

		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.HOUR).setCount(1).setText("1h"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.DAY).setCount(1).setText("1D"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.ALL).setCount(1).setText("ALL"));
		chartOptions.getRangeSelector().setSelected(1).setInputEnabled(false);
		
		SeriesArea seriesArea = new SeriesArea();
		seriesArea.setType(SeriesType.AREA).setName("AAPL").setGapSize(5).setThreshold(NullOption.NULL_NUMBER);
		seriesArea.getTooltip().setValueDecimals(2);
		
		ArrayList<Stop> stops = new ArrayList<Stop>();
		stops.add(new Stop(0, chartOptions.getColors().get(0)));
		stops.add(new Stop(1, new Color().setColorValue("Highcharts.color(Highcharts.getOptions().colors[0]).setOpacity(0).get('rgba')")));
		seriesArea.setFillColor(new Color(new LinearGradient(0, 0, 0, 1), stops));
		
		seriesArea.getDataAsJsValue().setJsValue(getSeriesData());
		chartOptions.getSeries().add(seriesArea);
		
		return highStock;
	}
	
	/**
	 * 
	 * @return
	 */
	private String getSeriesData() {
		// Some of our example charts use a REST service to retrieve data.
		// REST service returns json data
		WebTarget webTarget = new RestService().getWebTarget();
		
		return webTarget.path("AAPLIntraDayJson").request().get(String.class);
	}
	
}