package com.webonlineapp.hyjavastockdemo9.examplecharts;

import javax.ws.rs.client.WebTarget;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.RangeSelectorButtonType;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.rangeselector.Buttons;
import com.hyjavastock.model.highstock.series.SeriesCandlestick;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;
import com.webonlineapp.hyjavastockdemo9.services.RestService;

public class IntraDayCandleStick extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL stock price by minute");

		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.HOUR).setCount(1).setText("1h"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.DAY).setCount(1).setText("1D"));
		chartOptions.getRangeSelector().getButtons().add(new Buttons().setType(RangeSelectorButtonType.ALL).setCount(1).setText("ALL"));
		chartOptions.getRangeSelector().setSelected(1).setInputEnabled(false);
		
		SeriesCandlestick seriesCandlestick = new SeriesCandlestick();
		seriesCandlestick.setType(SeriesType.CANDLESTICK).setName("AAPL");
		seriesCandlestick.getTooltip().setValueDecimals(2);
	
		seriesCandlestick.getDataAsJsValue().setJsValue(getSeriesData());
		chartOptions.getSeries().add(seriesCandlestick);
		
		return highStock;
	}
	
	/**
	 * 
	 * @return
	 */
	private String getSeriesData() {
		// Some of our example charts use a REST service to retrieve data.
		// REST service returns json data
		WebTarget webTarget = new RestService().getWebTarget();
		
		return webTarget.path("AAPLIntraDayJson").request().get(String.class);
	}
	
}