package com.webonlineapp.hyjavastockdemo9.examplecharts;

import java.util.ArrayList;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.common.LinearGradient;
import com.hyjavastock.model.common.NullOption;
import com.hyjavastock.model.common.Stop;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.ChartType;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesArea;
import com.webonlineapp.hyjavastockdemo9.chartdata.AAPLCloseData;
import com.webonlineapp.hyjavastockdemo9.charts.DemoChartBase;

public class ReversedYAxis extends DemoChartBase {
	private static final long serialVersionUID = 8451224834547659420L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getChart().setType(ChartType.AREA);
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(1);

		chartOptions.getYAxisSingle().setReversed(true).setShowFirstLabel(false).setShowLastLabel(true);
		
		SeriesArea seriesArea = new SeriesArea();
		seriesArea.setType(SeriesType.AREA).setName("AAPL Stock Price").setThreshold(NullOption.NULL_NUMBER);
		seriesArea.getTooltip().setValueDecimals(2);
		
		ArrayList<Stop> stops = new ArrayList<Stop>();
		stops.add(new Stop(0, chartOptions.getColors().get(0)));
		stops.add(new Stop(1, new Color().setColorValue("Highcharts.color(Highcharts.getOptions().colors[0]).setOpacity(0).get('rgba')")));
		seriesArea.setFillColor(new Color(new LinearGradient(0, 0, 1, 0), stops));
		
		seriesArea.getDataAsJsValue().setJsValue(new AAPLCloseData().get());
		chartOptions.getSeries().add(seriesArea);
		
		return highStock;
	}
	
}