package com.webonlineapp;

import java.io.Serializable;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavacharts.chart.Highchart;
import com.hyjavastock.chart.Highstock;

/*
 * A simple proof of concept example application to show how to integrate  
 *   Highcharts and the HyJavaCharts library
 * plus
 *   Highcharts Stock and the HyJavaStock library
 * plus
 *   ApexCharts and the HyJavaApex library 
 *   
 * in a JSF application.
 * 
 * NOTE: We are not experts in JSF so there will no doubt be better ways to accomplish the same thing.
 * 
 */
@ManagedBean
@RequestScoped 
public class ChartDemo implements Serializable {

	private static final long serialVersionUID = 1L;	

	private String chartName = "line";
	private String globalOptions = "";
	private String chartOptions = "";
	

	/**
	 * 
	 * @return
	 */
	public String chartSelect() {
		if (chartName.equals("stock")) {
			Highstock hs = new HighstockColumn().configure();
			chartOptions = hs.chartOptionsToJs();
			
			return "highstockresponse";
		}
		else if (chartName.equals("apex")) {
			Apexchart apexchart = new ApexChartsBasicColumn().configure();
			chartOptions = apexchart.chartOptionsToJs();
			
			return "apexchartresponse";
		}
		else {
			Highchart hc = null;
			
			if (chartName.equals("line")) {
				hc = new HighchartsLine().configure();
				chartOptions = hc.chartOptionsToJs();
			}
			else {
				hc = new HighchartsPie().configure();
				chartOptions = hc.chartOptionsToJs();
			}
			
			return "highchartsresponse";
		}
	}

	public String getChartOptions() {
		return chartOptions;
	}

	public void setChartOptions(String chartOptions) {
		this.chartOptions = chartOptions;
	}

	public String getChartName() {
		return chartName;
	}

	public void setChartName(String chartName) {
		this.chartName = chartName;
	}

	public String getGlobalOptions() {
		return globalOptions;
	}

	public void setGlobalOptions(String globalOptions) {
		this.globalOptions = globalOptions;
	}

}
