package com.webonlineapp.action;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavacharts.chart.Highchart;
import com.hyjavastock.chart.Highstock;
import com.webonlineapp.charts.ApexChartsBasicColumn;
import com.webonlineapp.charts.HighchartsLine;
import com.webonlineapp.charts.HighchartsPie;
import com.webonlineapp.charts.HighstockColumn;

/*
 * A simple proof of concept example application to show how to integrate
 *   Highcharts and the HyJavaCharts library
 * plus
 *   Highcharts Stock and the HyJavaStock library
 * plus
 *   ApexCharts and the HyJavaApex library 
 *   
 * in a Struts2 application.
 * 
 * NOTE: We are not experts in Struts2 so there will no doubt be better ways to accomplish the same thing.
 * 
 */
public class HomeAction{
	
	private String chartName;
	private String globalOptions;
	private String chartOptions;
	
	
	/**
	 * 
	 * @return
	 */
	public String execute() {
		if (chartName.equals("stock")) {
        	Highstock hs = new HighstockColumn().configure();
        	
        	globalOptions = hs.globalOptionsToJs();
			chartOptions = hs.chartOptionsToJs();
	
			return "HIGHSTOCK";
		}
		else if (chartName.equals("apex")) {
			Apexchart apexchart = new ApexChartsBasicColumn().configure();
        	
			chartOptions = apexchart.chartOptionsToJs();
	
			return "APEXCHARTS";
		}
		else {
			Highchart hc = null;
			
			if (chartName.equals("line")) {
				hc = new HighchartsLine().configure();
			}
			else {
				hc = new HighchartsPie().configure();
			}
			
			globalOptions = hc.globalOptionsToJs();
			chartOptions = hc.chartOptionsToJs();
	
			return "HIGHCHARTS";
		}
	}
	 

	public String getChartName() {
		return chartName;
	}

	public void setChartName(String chartName) {
		this.chartName = chartName;
	}

	public String getGlobalOptions() {
		return globalOptions;
	}

	public void setGlobalOptions(String globalOptions) {
		this.globalOptions = globalOptions;
	}

	public String getChartOptions() {
		return chartOptions;
	}

	public void setChartOptions(String chartOptions) {
		this.chartOptions = chartOptions;
	}
	
}